/*
 * File         : AbstractExpressionInspector.java
 * Author       : Han-Ku Lee
 * Created      : Tue Oct 20 21:22:25 1998
 * Revision     : $Revision: 1.11 $
 * Updated      : $Date: 1999/12/01 18:57:21 $
 */

// this is not finished. 
 
 
package hpjava.compiler.abstractexp; 

import java.util.*;

import hpjava.compiler.util.*;  
import hpjava.compiler.syntaxtree.*;  
import hpjava.compiler.reflection.*; 
import hpjava.compiler.wrapper.*;
 
 
public class AbstractExpressionInspector extends AbstractExpressionVisitor {
  boolean hasMetPrefix = false;
  
  final int PREFIX = 0;
  final int SUFFIX = 1;

  ExpressionConversion_abstractexp EC = new ExpressionConversion_abstractexp();

  //  private ClassReflector cr;
  private IntStack status = new IntStack();
  
  private StringBuffer image = new StringBuffer();

  public AbstractExpressionInspector () {
    status.push(PREFIX);
    // for simple expression, it is a prefix.
  }
  
  public void visit(AssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in AssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in AssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("Assignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in AssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(AdditionAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in AdditionAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in AdditionAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      //System.out.println("1");
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      //System.out.println("2");
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      //System.out.println("3");
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      //System.out.println("4");
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      //System.out.println("5");
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      //System.out.println("6");
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      //System.out.println("7");
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      //System.out.println("7-2");
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        //System.out.println("8");
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        //System.out.println("9");
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        //System.out.println("10");
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          //System.out.println("11");
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        //System.out.println("12");
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        //System.out.println("13");
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        //System.out.println("14");
        n.cr = n.left.cr;
      } 
        //System.out.println("15");     
    }
    else
      throw new Error("AdditionAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in AdditionAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(SubtractionAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in SubtractionAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in SubtractionAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("SubtractionAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in SubtractionAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(MultiplicationAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in MultiplicationAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in MultiplicationAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("MultiplicationAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in MultiplicationAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(DivisionAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in DivisionAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in DivisionAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("DivisionAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in DivisionAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(AndAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in AndAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in AndAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("AndAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in AndAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(InclusiveOrAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in InclusiveOrAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in InclusiveOrAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("InclusiveOrAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in InclusiveOrAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(ExclusiveOrAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in ExclusiveOrAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in ExclusiveOrAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("ExclusiveOrAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in ExclusiveOrAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(LeftShiftAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in LeftShiftAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in LeftShiftAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("LeftShiftAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in LeftShiftAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(RightShiftAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in RightShiftAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in RightShiftAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("RightShiftAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in RightShiftAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(ModulusAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in ModulusAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in ModulusAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("ModulusAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in ModulusAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  public void visit(ExtensionRightShiftAssignmentNode n) {
    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("n.left.cr.getName() in ExtensionRightShiftAssignmentNode: " + n.left.cr.getName());
    //System.out.println("n.right.cr.getName() in ExtensionRightShiftAssignmentNode: " + n.right.cr.getName());

    // Assignment conversion has to be here ...

    if(n.left.cr.getName().equals(n.right.cr.getName())){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isSuperclassOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isInterfaceOf(n.right.cr)){
      n.cr = n.left.cr;
    }
    else if((n.left.cr.isInterface() || n.left.cr.isArray() || !n.left.cr.isInterface())
            && n.right.cr.getName().equals("hpjava.compiler.abstractexp.NullNode")){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isInterface()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Object") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.getName().equals("java.lang.Cloneable") && n.right.cr.isArray()){
      n.cr = n.left.cr;
    }
    else if(n.left.cr.isArray() && n.right.cr.isArray()){
      if(n.left.cr.getComponentType().getName().equals(n.right.cr.getComponentType().getName())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isSuperclassOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterfaceOf(n.right.cr.getComponentType())){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().isInterface() 
              || n.left.cr.getComponentType().isArray() 
              || !n.left.cr.getComponentType().isInterface()){
        if(n.right.cr.getComponentType().getName().equals("hpjava.compiler.abstractexp.NullNode")){
          n.cr = n.left.cr;
        }
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isInterface()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Object") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }
      else if(n.left.cr.getComponentType().getName().equals("java.lang.Cloneable") 
              && n.right.cr.getComponentType().isArray()){
        n.cr = n.left.cr;
      }      
    }
    else
      throw new Error("ExtensionRightShiftAssignment Conversion is NOT proper ...");

    //System.out.println("n.cr.getName() in ExtensionRightShiftAssignmentNode: " + n.cr.getName());
    //System.out.println();

    n.typeChecked = true;
  }

  //
  // f0 -> ConditionalOrExpression()
  // f1 -> [ "?" Expression() ":" ConditionalExpression() ]
  //
  public void visit(ConditionalNode n) {
    n.condition.accept(this);

    if(n.trueResult != null || n.falseResult != null){
      n.trueResult.accept(this);
      n.falseResult.accept(this);
    }

    n.cr = n.trueResult.cr;

    n.typeChecked = true;
  }

  //
  // f0 -> Operator
  // f1 -> AbstractExpression()
  // f2 -> AbstractExpression()
  //
  public void visit(BinExprNode n) {
    //String image;
    String tmp_type;

    n.left.accept(this);
    n.right.accept(this);

    //System.out.println("left n.left.getClass().getName(): " + n.left.getClass().getName());
    //System.out.println("right n.right.getClass().getName(): " + n.right.getClass().getName());

    //System.out.println("n.binaryOperator" + n.binaryOperator);
    //System.out.println("left n.left.cr.getName(): " + n.left.cr.getName());
    //System.out.println("right n.right.cr.getName(): " + n.right.cr.getName());

    tmp_type = EC.string_conversion(n.left.cr, n.right.cr);
    //System.out.println("tmp_type in BinExprNode: " + tmp_type);
    /*
    if(n.left.cr.getName().startsWith("hpjava.lang.Array")){
      ArraySectNode ggg = (ArraySectNode)n.left;
      System.out.println("ggg.arrayName.cr.getName(): " + ggg.arrayName.cr.getName());
    }
    else{
      System.out.println("It's Not Starting with Array ...");
    }
    
    System.out.println("n.left.cr.getName(): " + n.left.cr.getName());
    System.out.println("n.binaryOperator = : " + n.binaryOperator);
    System.out.println("n.right.cr.getName(): " + n.right.cr.getName());
    System.out.println();
    */
    try{
      //System.out.println("right n.right.getClass().getName(): " + n.right.getClass().getName());
      if(ClassReflector.forName("hpjava.lang.Group").isSuperclassOf(n.left.cr)
         && n.binaryOperator == 18
         && (n.right.cr.getName().equals("hpjava.lang.Location")
             || ((n.right.cr.getName().equals("hpjava.lang.Range")
                 || n.right.cr.getName().equals("hpjava.lang.BlockRange")
                 || n.right.cr.getName().equals("hpjava.lang.CyclicRange")
                 || n.right.cr.getName().equals("hpjava.lang.BlockCyclicRange"))
                 && n.right.getClass().getName().equals("hpjava.compiler.abstractexp.ArrayElemRefNode"))))
        n.cr = ClassReflector.forName(n.left.cr.getName());
      else if(n.left.cr.getName().startsWith("hpjava.lang.Array")
              && n.binaryOperator == 18
              && n.right.cr.getName().equals("hpjava.lang.Location")){
        // Do Something ... like Array1dF ==> Array2ddF
        ArraySectNode arraySect = (ArraySectNode)n.left;
        n.cr = ClassReflector.forName(arraySect.arrayName.cr.getName());
      }
      else
        n.cr = ClassReflector.forName(tmp_type);

      //n.getParent().cr = n.cr;  // important ...
    }
    catch(ClassNotFoundException e){
      System.out.println("ClassNotFoundException...");
    }

    //System.out.println("%%%%%%% n.cr.getName() in BinExprNode: " + n.cr.getName());

    n.typeChecked = true;
  }

  //
  // f0 -> Operator
  // f1 -> AbstractExpression()
  //
  public void visit(UnaryExprNode n) {
    String tmp_type;

    n.operand.accept(this);

    //System.out.println("n.uOperator in UnaryExprNode: " + n.uOperator);

    //System.out.println("n.cr.getName() in UnaryExprNode: " + n.cr.getName());
    /*
    tmp_type = unary_numeric_promotion(n.operand.cr.getName());

    try{
      n.cr = ClassReflector.forName(tmp_type);
      //n.getParent().cr = n.cr;  // important ...
    }
    catch(ClassNotFoundException e){
      System.out.println("ClassNotFoundException...");
    }
    */
    if(n.uOperator != n.POSTFIX_INDEX_LOCATION)
      n.cr = n.operand.cr;
    else{
      try{
        n.cr = ClassReflector.forName("int");
        //n.getParent().cr = n.cr;  // important ...
      }
      catch(ClassNotFoundException e){
        System.out.println("ClassNotFoundException...");
      }
    }
    
    //System.out.println("n.cr.getName() in UnaryExprNode: " + n.cr.getName());

    n.typeChecked = true;
  }
  
  public void visit (MethodCallNode n) {
    status.push(PREFIX);   
    n.objName.accept(this);
    status.pop();

    status.push(SUFFIX);
    n.methodName.accept(this);
    n.args.accept(this);
    status.pop();

    n.cr = n.methodName.cr;

    n.typeChecked = true;
  }

  public void visit (ClassFieldNode n) {
    status.push(PREFIX);   
    n.objName.accept(this);
    status.pop();

    status.push(SUFFIX);
    n.fieldName.accept(this);
    status.pop();

    n.cr = n.fieldName.cr;

    n.typeChecked = true;
  }

  public void visit (ArrayElemRefNode n) {
    status.push(PREFIX);   
    n.arrayName.accept(this);
    status.pop();

    NodeChoice nc = (NodeChoice)n.eList.descriptor.leaf.f0.f0;

    status.push(SUFFIX);
    n.eList.accept(this);
    status.pop();

    String tmp = n.arrayName.cr.getName();
    //System.out.println("n.arrayName.cr.getName() in ArrayElemRefNode: " + n.arrayName.cr.getName());
    //System.out.println("n.eList.cr.getName() in ArrayElemRefNode: " + n.eList.cr.getName());
    //System.out.println("n.eList.getClass().getName() in ArrayElemRefNode: " + n.eList.getClass().getName());
    //System.out.println("n.arrayName.cr.getComponentType().getName() in ArrayElemRefNode: " + n.arrayName.cr.getComponentType().getName());

    //NodeChoice nc = (NodeChoice)n.eList.descriptor.leaf.f0.f0;

    // if array is Triplet ...
    if(nc.which == 0){
      n.cr = n.arrayName.cr;
      //System.out.println("nc.which == 0 in ArrayElemRefNode");
    }
    // if array is Expression ...
    else{
      if(n.arrayName.cr.getName().equals("hpjava.lang.Range")
         || n.arrayName.cr.getName().equals("hpjava.lang.BlockRange")
         || n.arrayName.cr.getName().equals("hpjava.lang.CyclicRange")
         || n.arrayName.cr.getName().equals("hpjava.lang.BlockCyclicRange")){
        n.cr = n.arrayName.cr;
        //System.out.println("nc.which == 1 in ArrayElemRefNode");
      }
      else{
        n.cr = n.arrayName.cr.getComponentType();
        //System.out.println("nc.which == 1 in ArrayElemRefNode");
      }
    }
    //n.cr = n.arrayName.cr;

    //System.out.println("&&&&&&&&&&& ArrayElemRefNode ... " + n.cr.getName());

    n.typeChecked = true;
  }

  public void visit (ArraySectNode n) {
    status.push(PREFIX);   
    n.arrayName.accept(this);
    status.pop();

    status.push(SUFFIX);
    n.dimList.accept(this);
    status.pop();

    String tmp = n.arrayName.cr.getName();
    //System.out.println("n.arrayName.cr.getName() in ArraySectNode: " + n.arrayName.cr.getName());

    NodeChoice nc = (NodeChoice)n.dimList.descriptor.leaf.f0.f0;
    //System.out.println("nc.which = " + nc.which);

    String _arrayName = n.arrayName.cr.getName().substring(0, n.arrayName.cr.getName().lastIndexOf("y")+1);
    StringBuffer _dim = new StringBuffer(n.arrayName.cr.getName().substring(n.arrayName.cr.getName().lastIndexOf("y")+2, n.arrayName.cr.getName().length()));
    int dim_length = Integer.parseInt(n.arrayName.cr.getName().substring(n.arrayName.cr.getName().lastIndexOf("y")+1, n.arrayName.cr.getName().lastIndexOf("y")+2));

    //System.out.println("_arrayName in ArraySectNode: " + _arrayName);
    //System.out.println("_dim in ArraySectNode: " + _dim.toString());
    //System.out.println("dim_length in ArraySectNode: " + dim_length);
    //System.out.println();

    StringBuffer new_dim = new StringBuffer();
    String _aexp = null;

    if(nc.which == 1){
      Expression exp = (Expression)nc.choice;
      AbstractExpression aexp = ExpressionManager.lookup(exp);
      _aexp = aexp.getClassReflector().getName();

      //System.out.println("&&&&&&& aexp.getClassReflector().getName(): " + aexp.getClassReflector().getName());
      //System.out.println("&&&&&&& aexp.getClass().getName(): " + aexp.getClass().getName());

      if(_aexp.equals("int") || _aexp.equals("hpjava.lang.Location") || 
         ((_aexp.equals("hpjava.lang.Range")
           || _aexp.equals("hpjava.lang.BlockRange")
           || _aexp.equals("hpjava.lang.CyclicRange")
           || _aexp.equals("hpjava.lang.BlockCyclicRange")) 
          && aexp.getClass().getName().equals("hpjava.compiler.abstractexp.ArrayElemRefNode")))
        dim_length--;
      else
        new_dim.append(_dim.substring(0,1));
    }
    else{
      new_dim.append(_dim.substring(0,1));
    }
    //System.out.println("_dim.substring(0,1): " + _dim.substring(0,1));

    //System.out.println("_arrayName in ArraySectNode: " + _arrayName);
    //System.out.println("new_dim in ArraySectNode: " + new_dim.toString());
    //System.out.println("dim_length in ArraySectNode: " + dim_length);
    //System.out.println();

    String dimension = new String();
    String _aexp2 = null;
    if(!((NodeListOptional)n.dimList.descriptor.leaf.f1).present()){
      new_dim = _dim;
      dimension = _arrayName + (new Integer(dim_length)).toString() + new_dim.toString();
    }
    
    if(((NodeListOptional)n.dimList.descriptor.leaf.f1).present()){
      //System.out.println("n.dimList.descriptor.leaf.f1.present()");

      for(int i=0; i<((NodeListOptional)n.dimList.descriptor.leaf.f1).size(); i++){
        NodeSequence seq = (NodeSequence)n.dimList.descriptor.leaf.f1.elementAt(i);
        DistArraySecRefDim dist = (DistArraySecRefDim)seq.elementAt(1);
        NodeChoice nc2 = (NodeChoice)dist.f0;

        if(nc2.which == 1){
          //System.out.println("nc2.which = " + nc2.which);

          Expression exp = (Expression)nc2.choice;
          AbstractExpression aexp = ExpressionManager.lookup(exp);
          _aexp2 = aexp.getClassReflector().getName();
          //System.out.println("&&&&&&& aexp.getClassReflector().getName(): " + aexp.getClassReflector().getName());
          //System.out.println("&&&&&&& aexp.getClass().getName(): " + aexp.getClass().getName());
                    
          if(_aexp2.equals("int") || _aexp2.equals("hpjava.lang.Location") || 
             ((_aexp2.equals("hpjava.lang.Range")
               || _aexp2.equals("hpjava.lang.BlockRange")
               || _aexp2.equals("hpjava.lang.CyclicRange")
               || _aexp2.equals("hpjava.lang.BlockCyclicRange")) 
              && aexp.getClass().getName().equals("hpjava.compiler.abstractexp.ArrayElemRefNode")))
            dim_length--;
          else
            new_dim.append(_dim.substring(i+1, i+2));

          //System.out.println("new_dim in ArraySectNode: " + new_dim.toString());          
        }
        else{
          //System.out.println("nc2.which = " + nc2.which);
          //System.out.println("new_dim in ArraySectNode: " + new_dim.toString());
          new_dim.append(_dim.substring(i+1, i+2));
        }
      }
      
      new_dim.append(_dim.substring(_dim.length()-1, _dim.length()));
      //System.out.println("^^^^^^^ new_dim in ArraySectNode: " + new_dim.toString());
      dimension = _arrayName + (new Integer(dim_length)).toString() + new_dim.toString();
      //System.out.println("^^^^^^^ dimension: " + dimension);
    }

    try{
      n.cr = ClassReflector.forName(dimension);
      //System.out.println("n.cr in ArraySectNode is " + n.cr.getName());
    }
    catch(ClassNotFoundException e){
      System.out.println("ArraySectNode is NOT properly excuted...");
    }

    n.typeChecked = true;
  }

  public void visit (InnerThisNode n) {
    status.push(PREFIX);   
    n.objName.accept(this);
    status.pop();

    status.push(SUFFIX);
    n.fieldName.accept(this);
    status.pop();

    n.typeChecked = true;
  }
  
  public void visit (InnerAllocationExpressionNode n) {
    status.push(PREFIX);   
    n.objName.accept(this);
    status.pop();

    status.push(SUFFIX);
    n.fieldName.accept(this);
    status.pop();

    n.typeChecked = true;
  }

  //
  // f0 -> "(" Type() ")" UnaryExpression()
  //       | "(" Type() ")" UnaryExpressionNotPlusMinus()
  //
  public void visit(CastNode n) {
    status.push(PREFIX);   
    n.type.accept(this);
    //status.pop();

    //status.push(SUFFIX);
    n.leaf.accept(this);
    status.pop();

    //System.out.println("CastNode in PREFIX");
    //System.out.println("n.type.leaf.f0.which: " + n.type.leaf.f0.which);

    try{
      //System.out.println("EC.cast_widening_narrowing_conversion(n): " + EC.cast_widening_narrowing_conversion(n));
      if(EC.cast_widening_narrowing_conversion(n) == null)
        throw new Error("Cast is NOT properly executed in CastNode ...");

      n.cr = ClassReflector.forName(EC.cast_widening_narrowing_conversion(n));

      //System.out.println("After cast_widening_narrowing_conversion in CastNode: " + n.cr.getName());
    }
    catch(ClassNotFoundException cnf){
      System.out.println("CastNode Not Found ...");
    }
    
		//table.put(n, n.cr);
    n.typeChecked = true;
  }

  public void visit (ThisNode n) {
    if (status.peek()==PREFIX) {
      NameSpaceDescriptor nsd = NameSpaceManager.nameSpaceOf(n.f0);

      try{
        //System.out.println("nsd.cname in ThisNode: " + nsd.cname);
        n.cr = ClassReflector.forName(nsd.cname);
				//table.put(n, n.cr);
      }
      catch(ClassNotFoundException cnf){
        System.out.println("ClassNotFoundException occurred ...");
      }
      
    }
    else if (status.peek()==SUFFIX) {

    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }
    
  public void visit (NullNode n) {
    if (status.peek()==PREFIX) {
				/*
      try{
        n.cr = ClassReflector.forName("hpjava.compiler.abstractexp.NullNode");
      }
      catch(ClassNotFoundException cnf){
        System.out.println("ClassNotFoundException occurred ...");
      }
				*/

			//System.out.println("NullNode in inspector...");
    }
    else if (status.peek()==SUFFIX) {
      // Do nothing ...
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (SuperNode n) {
    if (status.peek()==PREFIX) {
			//System.out.println("SuperNode in inspector...");
			
    }
    else if (status.peek()==SUFFIX) {
      // can not be used as suffix
      throw new Error();
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  /**
   * f0 -> INTEGER_LITERAL;
   *       | FLOATING_POINT_LITERAL;
   *       | CHARACTER_LITERAL;
   *       | STRING_LITERAL;
   *       | BooleanLiteral()
   *       | NullLiteral()
   */
  public void visit (LiteralNode n) {
    if (status.peek()==PREFIX) {
      //System.out.println("*LiteralNode which: " + n.leaf.f0.which);
      //System.out.println("*LiteralNode tokenImage: " + ((NodeToken)n.leaf.f0.choice).tokenImage);
        
      String tmp;

      switch(n.leaf.f0.which){
      case 0:
        tmp = "int";
        break;
      case 1:
        tmp = "double";
        break;
      case 2:
        tmp = "char";
        break;
      case 3:
        tmp = "java.lang.String";
        break;
      case 4:
        tmp = "boolean";
        break;
      case 5:
        tmp = "hpjava.compiler.abstractexp.NullNode";
        break;
      default:
        throw new Error("Unexpected case ...");
      }
        
      try{
        n.cr = ClassReflector.forName(tmp);
        //System.out.println("n.cr.getName() in Literal Node: " + n.cr.getName());
      }
      catch(ClassNotFoundException cnf){
        System.out.println("Literal " + tmp + " Not Found ...");
      }

    }
    else if (status.peek()==SUFFIX) {
      // literal can not be used as suffix
      throw new Error();
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (ClassLiteralNode n) {
    if (status.peek()==PREFIX) {
      //System.out.println("ClassLiteralNode in inspector...");
    }
    else if (status.peek()==SUFFIX) {
      // literal can not be used as suffix
      throw new Error();
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (TripletOrExpressionListNode n) {
    if (status.peek()==PREFIX) {
      throw new Error();
    }
    else if (status.peek()==SUFFIX) {
      // Stupid code ... has to be changed ... Written in 1999

      try{
        n.cr = ClassReflector.forName("int");
        n.getParent().cr = n.cr;

        //System.out.println("n.cr.getName() in TripletOrExpressionList: " + n.cr.getName());
      }
      catch(ClassNotFoundException cnf){
        System.out.println("TripletOrExpressionList Not Found ...");
      }
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }  
  
  public void visit (DistArraySecRefDimListNode n) {
    if (status.peek()==PREFIX) {
      throw new Error();
    }
    else if (status.peek()==SUFFIX) {
      //System.out.println("DistArraySecRefDimListNode in inspector...");
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }

  //private StringBuffer strBuf = new StringBuffer();

 /* 
  * f0 -> ( PrimitiveType() | Name() )
  * f1 -> ( ArraySignature() )*
  */    
  public void visit(TypeNode n){
    ClassReflectorDescriptor crd = null;
    if(n.leaf.f0.which == 0){
      PrimitiveType nc = (PrimitiveType)n.leaf.f0.choice;
      crd = new PrimitiveTypeDescriptor(nc);
    }
    else if(n.leaf.f0.which == 1){
      Name _name = (Name)n.leaf.f0.choice;
      NodeToken leaf = _name.f0;
      NameSpaceDescriptor nsd = NameSpaceManager.nameSpaceOf(leaf);
      
      String export_name;
      export_name = ExportedClassNameManager.resolve(nsd.pname(), nsd.inames, leaf.tokenImage);

      crd = new ClassTypeDescriptor(nsd.pname(), nsd.inames, _name);
    }

    //if(crd.signature().startsWith("L") && crd.signature().endsWith(";"))
    //  crd.signature = crd.signature().substring(1, crd.signature().lastIndexOf(";"));

    if(n.leaf.f1.present()){
      // What if the Signature is for DistArray or GS ???
      for(int i=0; i<n.leaf.f1.size(); i++){
        crd = new ArrayReflectorDescriptor(crd, "[");
      }
    }
    else{
      if(crd.signature().startsWith("L") && crd.signature().endsWith(";"))
        crd.signature = crd.signature().substring(1, crd.signature().lastIndexOf(";"));      
    }

    //System.out.println("crd.signature() in TypeNode: " + crd.signature());

    try{
      n.cr = ClassReflector.forName(crd.signature());
      //System.out.println("############ n.cr.getName() in TypeNode: " + n.cr.getName());
    }
    catch(ClassNotFoundException cnf){
      System.out.println(crd.signature() + "Not Found in TypeNode ...");
    }
    
    n.typeChecked = true;
  }

  public void visit (IdentifierNode n) {
    //System.out.println("*******************");
    //System.out.println("       " +n.leaf.tokenImage);
    //System.out.println();

    if(status.peek()==PREFIX) {
      // Local Variable???
      try{
        //System.out.println("LocalVariable in PREFIX ...");
        ClassReflectorDescriptor crd = 
          LocalVariableManager.classReflectorDescriptorOf(n.leaf);

        //System.out.println("crd.signature(): " + crd.signature());

        if(crd.signature().startsWith("L") && crd.signature().endsWith(";"))
          crd.signature = crd.signature().substring(1, crd.signature().lastIndexOf(";"));

        n.cr = new ClassReflectorByDescriptor(crd);
        //n.getParent().cr = n.cr;  // important ...

        //System.out.println("LocalVariable " + n.leaf.tokenImage + " has type " + n.cr.getName());
        //System.out.println(" Signature: " + crd.toString());
        //System.out.println("Found in Local Variable ...");
        //System.out.println();
      }
      catch(NoSuchNameException e){
        // Class Field???
        // What if the Field is static member?
        // Then it can't be recognized currently...
        NameSpaceDescriptor nsd = NameSpaceManager.nameSpaceOf(n.leaf);

        try{
          //System.out.println("Class Field in PREFIX ...");
          //System.out.println("nsd.cname: " + nsd.cname);

          ClassReflector clscr = ClassReflector.forName(nsd.cname);
          //System.out.println("clscr: " + clscr.getName());
          //System.out.println("nsd.cname: " + nsd.cname);

          try{
            //System.out.println("************ " +clscr.getDeclaredField(n.leaf.tokenImage));
            //System.out.println("getTypeName: " + clscr.getDeclaredField(n.leaf.tokenImage).getTypeName());
            n.cr = 
              ClassReflector.forName(clscr.getDeclaredField(n.leaf.tokenImage).getTypeName());
            //n.getParent().cr = n.cr;  // Important.....

            //System.out.println("Field " + n.leaf.tokenImage + " has type " + n.cr.getName());
            //System.out.println("Found in Class Field ...");
            //System.out.println();
          }
          catch(NoSuchFieldException ef){
            // package, import ?
            //System.out.println("Package, Import in PREFIX ...");
            /*
            StringBuffer pack = new StringBuffer(nsd.pnameBuffer.toString());

            if(nsd.pnameBuffer.length() == 0)
              pack = pack.append(n.leaf.tokenImage);
            else
              pack = pack.append("." + n.leaf.tokenImage);
            */

            //System.out.println("Import in PREFIX ...");
            //System.out.println("nsd.inames: " + nsd.inames.toString());
            //System.out.println("nsd.inames.size(): " + nsd.inames.size());

            String export_name;
            export_name = ExportedClassNameManager.resolve(nsd.pname(), nsd.inames, n.leaf.tokenImage);
            //System.out.println("**** ExportedClassNameManager.resolve's export_name: " + export_name);
            try{

              if(export_name == null)
                throw new ClassNotFoundException();
              //Class cl = null;

            //try{
                /*
              Class cls = Class.forName(pack.toString());
              n.cr = new ClassReflectorByByteCode(cls);

              System.out.println("package " + pack + " is " + n.cr.getName()); 
              System.out.println("Found in Package ...");
              System.out.println();
                */

                //cl = Class.forName(export_name);
                //n.cr = new ClassReflectorByByteCode(cl);
              n.cr = ClassReflector.forName(export_name);

              //System.out.println("n.cr.getName() in package, import: " + n.cr.getName());

            }
            catch(ClassNotFoundException cnf2){
              // super class?
              //System.out.println("Super Class in Prefix ...");

              if(clscr.getSuperclass() == null){
                System.out.println("Super Class of " + n.leaf.tokenImage + " Not Found");
              }
              else{
                try{
									System.out.println("super_class_field_toString(n.leaf.tokenImage, clscr, n): " + super_class_field_toString(n.leaf.tokenImage, clscr, n));
                  n.cr = ClassReflector.forName(super_class_field_toString(n.leaf.tokenImage, clscr, n));

                  //System.out.println("Found in Super Class's Field ...");
                  //System.out.println();
                }
                catch(ClassNotFoundException cnf3){
                  try{
                    n.cr = ClassReflector.forName(super_class_method_toString(n.leaf.tokenImage, clscr, n));

                    //System.out.println("Found in Super Class's Method ...");
                    //System.out.println();
                  }
                  catch(ClassNotFoundException cnf4){
                    NodeToken node = n.leaf;
                    System.out.println("?????????" + node.tokenImage);
                    image.append(node.tokenImage);
                  }
                }
              }

            // Package, import, super class, or inner class?
            }

            //NodeToken node = n.leaf;
            //System.out.println("?????????" + node.tokenImage);
            //image.append(node.tokenImage);
          }

        }
        catch(ClassNotFoundException cnf){
          System.out.println("ClassNotFoundException occurred...");
        }

      }
    }
    else if(status.peek()==SUFFIX) {
      // Class Field???
      // What if the Field is static member?
      // Then it can't be recognized currently...

      //System.out.println("Class Field in SUFFIX ...");

      AbstractExpression ae = n.getParent();
      AbstractExpression id;

      if(ae.getClass().getName().equals("hpjava.compiler.abstractexp.ClassFieldNode")){
        id = (AbstractExpression)((ClassFieldNode)ae).objName;
        //System.out.println("ClassFieldNode");
      }
      else{
        id = (AbstractExpression)((MethodCallNode)ae).objName;
        //System.out.println("MethodCallNode");
      }

      try{
        ClassReflector clscr;
        NameSpaceDescriptor nsd = NameSpaceManager.nameSpaceOf(n.leaf);

        if(id.cr != null){
          //System.out.println("id is Not NULL ...");
          clscr = ClassReflector.forName(id.cr.getName());
        }
        else{
          //System.out.println("id is NULL ...");
          clscr = ClassReflector.forName(nsd.cname);
        }

        try{
          //System.out.println("clscr.getName() in SUFFIX: " + clscr.getName());
          
          if(n.leaf.tokenImage == "length")
            n.cr = ClassReflector.forName("int");
          else
            n.cr =  ClassReflector.forName(clscr.getDeclaredField(n.leaf.tokenImage).getTypeName());

          n.getParent().cr = n.cr;  // Important.....

          //System.out.println("Field " + n.leaf.tokenImage + " has type " + n.cr.getName());
          //System.out.println("Found in Class Field ...");
          //System.out.println();
        }
        catch(NoSuchFieldException ef){
          // super class's field ???
          //System.out.println("Super Class Field in SUFFIX ...");

          try{
            if(clscr.getSuperclass() == null){
              throw new ClassNotFoundException();
            }
            else{
              String _field = super_class_field_toString(n.leaf.tokenImage, clscr, n);
              
              if(_field == null)
                throw new ClassNotFoundException();
              else{
                n.cr = ClassReflector.forName(_field);
                //System.out.println("Field " + n.leaf.tokenImage + " has type " + n.cr.getName());
                //System.out.println("Found in Class Field ...");
              }
            }
          }
          catch(ClassNotFoundException cnf4){

            // Class Method???
            //System.out.println("Method in SUFFIX ...");

            try{
              //System.out.println("clscr.getName() in SUFFIX: " + clscr.getName());
              //System.out.println("clscr in SUFFIX: " + clscr);

              //System.out.println("n.getParent().getClass().getName() in SUFFIX: " + n.getParent().getClass().getName());
              
              if(((MethodCallNode)n.getParent()).objName.getClass().getName().equals("hpjava.compiler.abstractexp.SuperNode")){
                n.cr = ClassReflector.forName(clscr.getSuperclass().getDeclaredMethod(n.leaf.tokenImage, argumentOf(n)).getReturnTypeName());
                
                //System.out.println("Method " + n.leaf.tokenImage + " has type " + n.cr.getName());
                //System.out.println("Found in Superclass Method ...");
                //System.out.println();
              }
              else{

                n.cr = ClassReflector.forName(clscr.getDeclaredMethod(n.leaf.tokenImage, argumentOf(n)).getReturnTypeName());
                //System.out.println("Method " + n.leaf.tokenImage + " has type " + n.cr.getName());
                //System.out.println("Found in Class Method ...");
                //System.out.println();
              }

              n.getParent().cr = n.cr;  // Important.....

            }
            catch(NoSuchMethodException em){
              // In java.lang.Object ???
              try{
                ClassReflector clscr2 = ClassReflector.forName("java.lang.Object");
                n.cr = ClassReflector.forName(clscr2.getDeclaredMethod(n.leaf.tokenImage, argumentOf(n)).getReturnTypeName());
                //System.out.println("n.cr.getName(): " + n.cr.getName());
                //System.out.println("Method " + n.leaf.tokenImage + " has type " + n.cr.getName());
                //System.out.println("Found in Class java.lang.Object ...");
              }
              catch(NoSuchMethodException em2){
                // super class method?

                //System.out.println("Super Class in Suffix ...");
                //System.out.println("clscr.getSuperclass().getName(): " + clscr.getSuperclass().getName());
                // Seems like getSuperclass() is not working correctly ...

                //System.out.println("clscr.getName() in Suffix: " + clscr.getName());
                //System.out.println("clscr in Suffix: " + clscr);

                if(clscr.getSuperclass() == null){
									//System.out.println("*** Super Class of " + n.leaf.tokenImage + " Not Found");

                  // Interface Method ???

                  //System.out.println("Method of Interface in Suffix ...");

                  if(clscr.isInterface()){
                    //System.out.println("clscr is Interface in SUFFIX ...");

                    try{
                      n.cr = ClassReflector.forName(clscr.getMethodOfInterface(n.leaf.tokenImage, argumentOf(n)).getReturnTypeName());
                      //System.out.println("Method " + n.leaf.tokenImage + " has type " + n.cr.getName());
                      //System.out.println("Found in Interface Method ...");
                    }
                    catch(NoSuchMethodException nsm){
                      NodeToken node = n.leaf;
                      System.out.println("?????????" + node.tokenImage);
                      image.append(node.tokenImage);
                    }

                  }
                  else{
                    NodeToken node = n.leaf;
                    System.out.println("?????????" + node.tokenImage);
                    image.append(node.tokenImage);
                  }

                }
                else{
                  try{
                    //System.out.println("n.leaf.tokenImage: " + n.leaf.tokenImage);
                    //System.out.println("super_class(n.leaf.tokenImage, clscr, n): " + super_class_method_toString(n.leaf.tokenImage, clscr, n));
                    n.cr = ClassReflector.forName(super_class_method_toString(n.leaf.tokenImage, clscr, n));

                    //System.out.println("Found in Super Class ...");
                    //System.out.println();
                  }
                  catch(ClassNotFoundException cnf3){
                    // Interface Method ???

                    //System.out.println("Method of Interface in Suffix ...");

                    if(clscr.isInterface()){
                      //System.out.println("clscr is Interface in SUFFIX ...");

                      try{
                        n.cr = ClassReflector.forName(clscr.getMethodOfInterface(n.leaf.tokenImage, argumentOf(n)).getReturnTypeName());
                        //System.out.println("Found in Interface Method ...");
                      }
                      catch(NoSuchMethodException nsm){
                        NodeToken node = n.leaf;
                        System.out.println("?????????" + node.tokenImage);
                        image.append(node.tokenImage);
                      }

                    }
                    else{
                      NodeToken node = n.leaf;
                      System.out.println("?????????" + node.tokenImage);
                      image.append(node.tokenImage);
                    }

                  }
                }

                //NodeToken node = n.leaf;
                //System.out.println("?????????" + node.tokenImage + " in SUFFIX");
                //image.append(node.tokenImage);
              }
            }
          }
        }
      }
      catch(ClassNotFoundException cnf){
        System.out.println("ClassNotFoundException occurred...");
      }

    }
    else {
      throw new Error();
    }

    n.typeChecked = true;
  }  

  protected String super_class_field_toString(String name, ClassReflector clscr, IdentifierNode n){
    String tmp = null;
    ClassReflector super_cr = null;
    ClassReflector class_ref = null;

    //while(clscr != null || clscr.getSuperclass() != null){
    while(clscr != null){
      if(clscr.getSuperclass() == null){
        break;
      }
      else{
        try{
          //System.out.println("clscr.getSuperclass() in super_class: " + clscr.getSuperclass());
          //System.out.println("name : " + name);
          super_cr = ClassReflector.forName(clscr.getSuperclass().getName());
          try{
            // super class's field?
            class_ref = ClassReflector.forName(super_cr.getDeclaredField(name).getTypeName());
          }
          catch(NoSuchFieldException ef){
            //System.out.println("Not Found in Super Class's Field ...");
          }

          if(class_ref == null){
            clscr = super_cr;
            //System.out.println("class_ref is NULL");
          }
          else{
            clscr = null;
            tmp = class_ref.getName();
            //System.out.println("class_ref is NOT NULL");
            //System.out.println("class_ref.getName(): " + class_ref.getName());
          }

        }
        catch(ClassNotFoundException cnf){
          System.out.println("Super class Not Found ...");
        }

      }
    }

		//System.out.println("tmp:" + tmp);
    return tmp;
  }

  protected String super_class_method_toString(String name, ClassReflector clscr, IdentifierNode n){
    String tmp = null;
    ClassReflector super_cr = null;
    ClassReflector class_ref = null;

    //while(clscr != null || clscr.getSuperclass() != null){
    while(clscr != null){
      if(clscr.getSuperclass() == null){
        break;
      }
      else{
        try{
          //System.out.println("clscr.getSuperclass() in super_class: " + clscr.getSuperclass());
          super_cr = ClassReflector.forName(clscr.getSuperclass().getName());
          try{
            // super class's method?
            //class_ref = ClassReflector.forName(super_cr.getDeclaredField(name).getTypeName());
            class_ref = ClassReflector.forName(super_cr.getDeclaredMethod(name, argumentOf(n)).getReturnTypeName());
          }
          catch(NoSuchMethodException ef){
            System.out.println("Not Found in Super Class's Method ...");
          }

          if(class_ref == null){
            clscr = super_cr;
            //System.out.println("class_ref is NULL");
          }
          else{
            clscr = null;
            tmp = class_ref.getName();
            //System.out.println("class_ref is NOT NULL");
            //System.out.println("class_ref.getName(): " + class_ref.getName());
          }

        }
        catch(ClassNotFoundException cnf){
          System.out.println("Super class Not Found ...");
        }

      }
    }

    return tmp;
  }

  private ClassReflector[] argumentOf(IdentifierNode n){
    MethodCallNode method = (MethodCallNode)n.getParent();

    //System.out.println("IdentifierNode n: " + n.leaf.tokenImage);
    //System.out.println("method.objName: " + method.objName.getClass().getName());

    ArgumentsNode arg = (ArgumentsNode)method.args;
    ClassReflector argument[] = new ClassReflector[arg.descriptor.numberOfArgs()];

    //System.out.println("arg.descriptor.numberOfArgs(): " + arg.descriptor.numberOfArgs());
    // What if argument is like a+b ?
    // in this case, arg.descriptor.numberOfArgs() is 1,
    // but Inspector behave like they are 2 ...
    for(int i=0; i<arg.descriptor.numberOfArgs(); i++){
      AbstractExpression aexp = arg.descriptor.abstractArg(i);

      argument[i] = aexp.getClassReflector();

      //System.out.println("aexp.getClassReflector().getClass(): " + aexp.getClassReflector().getName());
      //System.out.println("aexp.getClass().getClass(): " + aexp.getClass().getName());
      //System.out.print("Argument " + i + " : ");
      //System.out.println(argument[i].getName());

    }

    return argument;
  }

  //
  // f0 -> "[" "[" Expression() ( "," Expression() )* "]" "]"
  //       | "[" Expression() "]"
  //
  private String signatureOf(AllocatedShape n) {
    StringBuffer buffer = new StringBuffer();
    if (n.f0.which == 0 ) {
      NodeSequence sequence = (NodeSequence) n.f0.choice;
      NodeListOptional list = (NodeListOptional) sequence.elementAt(3);
      buffer.append(']');

      buffer.append(String.valueOf(1+list.size()));
      
      Expression exp = (Expression) sequence.elementAt(2);
      AbstractExpression aexp = ExpressionManager.lookup(exp);
      
      String typeName = aexp.getClassReflector().getName();
      //System.out.println("1st signature is " + typeName);

      if (typeName.equals("int")) {
        buffer.append('c');
      }
      else if(typeName.equals("hpjava.lang.Range")
              || typeName.equals("hpjava.lang.BlockRange")
              || typeName.equals("hpjava.lang.CyclicRange")
              || typeName.equals("hpjava.lang.BlockCyclicRange")
              || typeName.equals("hpjava.lang.Dimension")) {
        //else if(typeName.equals("java.lang.Integer")) {
        buffer.append('d');
      }
      else {
        throw new Error("compiling err, not finished");
      }

      if (list.present()) {
        for (int i = 0; i< list.size(); i++) {
          exp =(Expression) ( (NodeSequence)list.elementAt(i) ).elementAt(1);
          aexp = ExpressionManager.lookup(exp);

          typeName = aexp.getClassReflector().getName();
          //System.out.println((i + 2) + "st signature is " + typeName);

          if (typeName.equals("int")) {
            buffer.append('c');
          }
          else if(typeName.equals("hpjava.lang.Range")
              || typeName.equals("hpjava.lang.BlockRange")
              || typeName.equals("hpjava.lang.CyclicRange")
              || typeName.equals("hpjava.lang.BlockCyclicRange")
              || typeName.equals("hpjava.lang.Dimension")) {
            //else if(typeName.equals("java.lang.Integer")) {
            buffer.append('d');
          }
          else {
            throw new Error("compiling err, not finished");
          }
        }

      }
    }
    else {
      buffer.append('[');
    }

    return buffer.toString();
  }

   //
   // f0 -> "new" PrimitiveType() ArrayShapes()
   //       | "new" Name() ( ArrayShapes() | Arguments() [ ClassBody() ] )
   //

  public void visit (AllocationExpressionNode n) {
    
    if (status.peek()==PREFIX) {
      //System.out.println("PREFIX");

      ClassReflectorDescriptor crd = null;

      if (n.descriptor.isPrimitiveTypeArrayAllocator()) {

        NodeSequence seq = (NodeSequence) n.descriptor.leaf.f0.choice;
        ArrayShapes as = (ArrayShapes)seq.elementAt(2);
        /*
        if(as.f0.which == 0){
          System.out.println("******* as.f0.which == 0");
        }
        else if(as.f0.which == 1){
          System.out.println("******* as.f0.which == 1");
        }
        else{
          System.out.println("******* as.f0.which == 2");
        }
        */
        crd = n.descriptor.primitiveType();
        
        int shapeNum = n.descriptor.numberOfAllocatedShapes();

        int signatureNum = n.descriptor.numberOfSignatures();
        //System.out.println("### signatureNum: " + signatureNum);
        //System.out.println("### crd.signature(): " + crd.signature());

        //NodeSequence seq2 = (NodeSequence)as.f0.choice;
        //NodeListOptional list = (NodeListOptional)seq2.elementAt(1);
        //ArraySignature array_sig = (ArraySignature)list.elementAt(signatureNum-1);

        if (signatureNum !=0){
          //  throw new Error("Not finished");
          NodeSequence seq2 = (NodeSequence)as.f0.choice;
          NodeListOptional list = (NodeListOptional)seq2.elementAt(1);
          ArraySignature array_sig = (ArraySignature)list.elementAt(signatureNum-1);

          if(as.f0.which == 0 && array_sig.f0.which == 1){
            StringBuffer strbuff = new StringBuffer();

            NodeSequence seq3 = (NodeSequence)array_sig.f0.choice;
            DistArrayDimAttList dadal = (DistArrayDimAttList)seq3.elementAt(2);
            
            strbuff.append(']');
            strbuff.append(String.valueOf(1+dadal.f1.size()));

            if(dadal.f0.present()){
              strbuff.append('c');
            }
            else{
              strbuff.append('d');
            }

            if(dadal.f1.present()){
              for(int i=0; i<dadal.f1.size(); i++){
                NodeOptional no = (NodeOptional)(((NodeSequence)dadal.f1.elementAt(i)).elementAt(1));
                if(no.present())
                  strbuff.append('c');
                else
                  strbuff.append('d');
              }
            }
            //crd.signature = strbuff.toString();
            //System.out.println("^^^^^^ crd.signature(): " + crd.signature());

            crd = new ArrayReflectorDescriptor (crd, strbuff.toString());

            for(int i=0; i<shapeNum+signatureNum-1; i++){
              crd = new ArrayReflectorDescriptor (crd, "[");
            }

          }
          else{
            for(int i = 0; i< n.descriptor.numberOfSignatures(); i++){
              crd = new ArrayReflectorDescriptor(crd, "[");
            }

            if (shapeNum == 0) {
              if (n.descriptor.isGSReference()){
                crd = new ArrayReflectorDescriptor (crd, "]0");
                //System.out.println("%%%%%%%% crd.signature(): " + crd.signature());
              }
              else
                throw new Error("Not finished");
            }
            else {
              //for (int i = 0; i< n.descriptor.numberOfAllocatedShapes(); i++) {
              for (int i = n.descriptor.numberOfAllocatedShapes()-1; i>=0 ; i--) {
                AllocatedShapeDescriptor descript = n.descriptor.allocatedShape(i);
                String image = signatureOf(descript.leaf);

                //System.out.println("signatureOf(descript.leaf): " + image);

                crd = new ArrayReflectorDescriptor(crd, image);
              }
            }

          }
        }
        else{
          //System.out.println("numberOfAllocatedShapes: " + shapeNum);
          //System.out.println("crd.signature(): " + crd.signature());
        
          if (shapeNum == 0) {
            if (n.descriptor.isGSReference())
              crd = new ArrayReflectorDescriptor (crd, "]0");
            else
              throw new Error("Not finished");
          }
          else {
            //for (int i = 0; i< n.descriptor.numberOfAllocatedShapes(); i++) {
            for (int i = n.descriptor.numberOfAllocatedShapes()-1; i>=0 ; i--) {
              AllocatedShapeDescriptor descript = n.descriptor.allocatedShape(i);
              String image = signatureOf(descript.leaf);

              //System.out.println("signatureOf(descript.leaf): " + image);

              crd = new ArrayReflectorDescriptor(crd, image);
            }
          }
        }
        if(crd.signature().startsWith("L") && crd.signature().endsWith(";"))
          crd.signature = crd.signature().substring(1, crd.signature().lastIndexOf(";"));

        //System.out.println("@@@@@@@ crd.signature(): " + crd.signature());

        try{
          n.cr = ClassReflector.forName(crd.signature());
          //System.out.println("$$$$$$$ n.cr.getName(): " + n.cr.getName());
        }
        catch(ClassNotFoundException cnf){
          System.out.println("ClassNotFoundException occurred ...");
        }
        
        //System.out.println("*** crd.signature(): " + crd.signature());


        //n.cr = new ClassReflectorByDescriptor(crd);

        //System.out.println("n.cr.getName(): " + n.cr.getName());

      }
      else if(n.descriptor.isClassAllocator()){
        NodeSequence sequence = (NodeSequence) n.descriptor.leaf.f0.choice;
        NodeToken leaf = ((Name)sequence.elementAt(1)).f0;
        NameSpaceDescriptor nsd = NameSpaceManager.nameSpaceOf(leaf);
        NodeChoice nc = (NodeChoice)sequence.elementAt(2);

        if(nsd == null){
          System.out.println("nsd in AllocationExpressionNode is empty ...");
        }
        else{
          //System.out.println("nsd in AllocationExpressionNode is NOT empty ...");
          //System.out.println("$$$$$$$ nsd.pnameBuffer: " + nsd.pnameBuffer.toString());
          //System.out.println("$$$$$$$ nsd.inames: " + nsd.inames.toString());
        }

        String export_name;
        export_name = ExportedClassNameManager.resolve(nsd.pname(), nsd.inames, leaf.tokenImage);
        //System.out.println("nsd.pname(): " + nsd.pname());
        //System.out.println("nsd.inames: " + nsd.inames);
        //System.out.println("leaf.tokenImage: " + leaf.tokenImage);
        /*
        ClassReflector temp = null;

        try{
          temp = ClassReflector.forName(export_name);
          System.out.println("&&&&&& temp.getName(): " + temp.getName());
        }
        catch(ClassNotFoundException cnf){
          System.out.println("ClassNotFoundException occurred ...");
        }
        */
        crd = new ClassTypeDescriptor(nsd.pname(), nsd.inames,(Name)sequence.elementAt(1));

        if(nc.which == 0){

          int shapeNum = n.descriptor.numberOfAllocatedShapes();

          //System.out.println("numberOfAllocatedShapes: " + shapeNum);
          //System.out.println("crd.signature(): " + crd.signature());

          if (shapeNum == 0) {
            if (n.descriptor.isGSReference())
              crd = new ArrayReflectorDescriptor (crd, "]0");
            else
              throw new Error("Not finished");
          }
          else {
            for (int i = 0; i< n.descriptor.numberOfAllocatedShapes(); i++) {
              AllocatedShapeDescriptor descript = n.descriptor.allocatedShape(i);
              String image = signatureOf(descript.leaf);

              //System.out.println("signatureOf(descript.leaf): " + image);

              crd = new ArrayReflectorDescriptor(crd, image);
            }
          }

          int signatureNum = n.descriptor.numberOfSignatures();
          //System.out.println("### signatureNum: " + signatureNum);
          //System.out.println("### crd.signature(): " + crd.signature());

          if (signatureNum !=0){
            //  throw new Error("Not finished");
            for(int i = 0; i< n.descriptor.numberOfSignatures(); i++){
              crd = new ArrayReflectorDescriptor(crd, "[");
            }
          }
          //System.out.println("*** crd.signature(): " + crd.signature());

          try{
            n.cr = ClassReflector.forName(crd.signature());
            //System.out.println("$$$$$$$ n.cr.getName(): " + n.cr.getName());
          }
          catch(ClassNotFoundException cnf){
            System.out.println("ClassNotFoundException occurred ...");
          }

          //n.cr = new ClassReflectorByDescriptor(crd);
          //System.out.println("n.cr.getName(): " + n.cr.getName());

          /*
          if(((NodeChoice)sequence.elementAt(2)).which == 0){
            System.out.println("whichChoice: " + ((NodeChoice)sequence.elementAt(2)).which);
          }
          else{
            System.out.println("whichChoice: " + ((NodeChoice)sequence.elementAt(2)).which);
          }
          */

        }
        else{ // if (nc.which == 1)
          // What if Name's f1 is present ???
          try{
            //System.out.println("&&&&&&& nc.which == 1");
            NodeListOptional nlo = ((Name)sequence.elementAt(1)).f1;
            String ext = leaf.tokenImage;

            for(int i=0; i<nlo.size(); i++){
              NodeSequence _seq = (NodeSequence)nlo.elementAt(i);
              //System.out.println(" ext : " + ext);
              //System.out.println("_seq.elementAt(0).getClass().getName(): " + _seq.elementAt(0).getClass().getName());
              //System.out.println("((NodeToken)_seq.elementAt(0)).tokenImage: " + ((NodeToken)_seq.elementAt(0)).tokenImage);
              //System.out.println("_seq.elementAt(1).getClass().getName(): " + _seq.elementAt(1).getClass().getName());
              //System.out.println("((NodeToken)_seq.elementAt(1)).tokenImage: " + ((NodeToken)_seq.elementAt(1)).tokenImage);
              ext = ext.concat(((NodeToken)_seq.elementAt(0)).tokenImage + ((NodeToken)_seq.elementAt(1)).tokenImage);               
            }

            if(export_name == null){
              //System.out.println("&&&&&&& ext in AllocationExpressionNode: " + ext);
              export_name = ExportedClassNameManager.resolve(nsd.pname(), nsd.inames, ext);
              n.cr = ClassReflector.forName(ext);
            }
            else{
              //System.out.println("&&&&&&& export_name in AllocationExpressionNode: " + export_name);
              n.cr = ClassReflector.forName(export_name);
            }

            //System.out.println("&&&&&& n.cr.getName(): " + n.cr.getName());              
            //throw new Error("&&&&&&& nc.which == 1");
          }
          catch(ClassNotFoundException cnf){
            System.out.println("ClassNotFoundException occurred ...");
          }

        }

      }

    }
    else if (status.peek()==SUFFIX) {
      //System.out.println("SUFFIX");

      throw new Error("Not finished.");
    }
    else {
      throw new Error();
    }

    n.typeChecked = true;

  }

  public void visit (ExpressionNode n) {
    if(status.peek()==PREFIX) {
      
      Expression exp = n.leaf;
      AbstractExpression aexp = ExpressionManager.lookup(exp);

      //System.out.println("aexp.getClassReflector().getName() in ExpressionNode: " + aexp.getClassReflector().getName());

      n.cr = aexp.getClassReflector();
      //System.out.println("########### n.cr in ExpressionNode: " + n.cr);

      //System.out.println("n.cr.getName() in ExpressionNode: " + n.cr.getName());
    }
    else if(status.peek()==SUFFIX) {
      // do nothing;
      throw new Error();
    }
    else{
      throw new Error();
    }

    n.typeChecked = true;
  }

  public void visit (ArgumentsNode n) {
    if (status.peek()==PREFIX) {
      // do nothing;
      throw new Error();
    }
    else if (status.peek()==SUFFIX) {
      //System.out.println("ArgumentsNode in inspector...");
    }
    else {
      throw new Error();
    }

    //n.typeChecked = true;
  }

}

/*

to do list:

complete the code for different cases
Rewrite most of them :-0

*/
