/*
 * File         : AllocationExpressionDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Wed Aug 12 14:23:07 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1999/11/11 02:30:16 $
 */

package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

import hpjava.compiler.reflection.*;

import hpjava.compiler.unparser.*;

//Following line is added by Qiang Zheng
// after moving the AllocationExpressionNode.java 
// to wrapper and creating this file

import hpjava.compiler.wrapper.*;

public class AllocationExpressionNode extends AbstractExpression {
  // public AllocationExpression leaf;
  public AllocationExpressionDescriptor descriptor;

  public AllocationExpressionNode (AllocationExpression leaf) {
    this.descriptor = new AllocationExpressionDescriptor(leaf);
  }

  public AllocationExpressionNode( ClassReflector cr ) {

	this.descriptor = new AllocationExpressionDescriptor(cr);
  }

  public void accept(AbstractExpressionVisitor v) {
    v.visit(this);
  }
  
  // This method is added by Qiang Zheng on Oct 1999
  // because in translation, replaceWith method cannot be
  // used in this class, this node doesn't have a parent node
  public void replaceDescriptor( AllocationExpressionDescriptor n ) {
    this.descriptor = n;
  }
}
