/*
 * File         : ArgumentsNode.java
 * Author       : Qiang Zheng
 * Created      : Sat Apr 25 14:23:07 1999
 * Revision     : $Revision: 1.2 $
 * Updated      : 
 */

/* Modified again to the new AST structure */

/* This is based on the original "ArgumentsDescripor" class
 * defined by Guansong Zhang
 * I move the class "ArgumentsDescripor" to the package "wrapper"
 * And keep some parts in the class in this new class
 */
package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

import hpjava.compiler.unparser.*;
import hpjava.compiler.wrapper.*;

public class ArgumentsNode extends AbstractExpression {
  // public Arguments leaf;
  public ArgumentsDescriptor descriptor;
  
  public void accept(AbstractExpressionVisitor v) {
    v.visit(this);
  }

  public ArgumentsNode (Arguments leaf) {
    this.descriptor = new ArgumentsDescriptor(leaf);
  }

  public ArgumentsNode () {
	this.descriptor = new ArgumentsDescriptor();
  }

  public ArgumentsNode (Expression n) {
    // this();
    // this.addArg(n);
    this.descriptor = new ArgumentsDescriptor();
    this.descriptor.addArg(n);
  }

  public ArgumentsNode (AbstractExpression n) {
    // this();
    // this.addArg(n);
    this.descriptor = new ArgumentsDescriptor();
    this.descriptor.addArg(n);
  }

}
