/*
 * File         : InnerAllocationExpressionNode.java
 * Author       : Han-Ku Lee
 * Created      : Sun Jun  6 19:35:00 1999
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/06/08 19:27:47 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1999
 */

package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class InnerAllocationExpressionNode extends AbstractExpression {
  public AbstractExpression objName;
  public AllocationExpressionNode fieldName;

  public InnerAllocationExpressionNode(AbstractExpression objName, 
                                       AllocationExpressionNode fieldName){
    this.objName = objName;
    this.fieldName = fieldName;
  }

  public void accept(AbstractExpressionVisitor v) {
    v.visit(this);
  }

}
