/*
 * File         : InnerThisNode.java
 * Author       : Han-Ku Lee
 * Created      : Sun Jun  6 19:31:06 1999
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/06/08 19:27:31 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1999
 */

package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class InnerThisNode extends AbstractExpression {
  public AbstractExpression objName;
  public ThisNode fieldName;

  public InnerThisNode(AbstractExpression objName, ThisNode fieldName){
    this.objName = objName;
    this.fieldName = fieldName;
  }

  public void accept(AbstractExpressionVisitor v) {
    v.visit(this);
  }

}
