/*
 * File         : PrimaryConcatenation.java
 * Author       : Guansong Zhang
 * Created      : Fri Aug 14 12:28:26 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1999/06/23 17:36:40 $
 */

/* Modified by Qiang Zheng on May 17
 * changed the architecture of AbstractPrimaryExpression
 */

package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class MethodCallNode extends AbstractExpression {
  public AbstractExpression objName;
  public IdentifierNode methodName;
  public AbstractExpression args;

  public MethodCallNode(AbstractExpression objName, 
			IdentifierNode methodname, 
			AbstractExpression argList)
  {
    this.objName = objName;
    this.methodName = methodname;
    this.args = argList;
  }

  public void accept(AbstractExpressionVisitor v) {
    v.visit(this);
  }

}

