/*
 * File         : TripletOrExpressionList.java
 * Author       : Guansong Zhang
 * Created      : Wed Aug 12 14:23:07 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1999/06/07 17:24:12 $
 */

/* Modified by Qiang Zheng
 * divide previous class "TripletOrExpressionListDescriptor"
 * into TripletOrExpressionListNode (still in this package)
 * and TripletOrExpressionListDescriptor (move to package wrapper)
 */

package hpjava.compiler.abstractexp;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;
import hpjava.compiler.wrapper.*;

public class TripletOrExpressionListNode extends AbstractExpression {
  // public TripletOrExpressionList leaf;
  public TripletOrExpressionListDescriptor descriptor;

  public TripletOrExpressionListNode (TripletOrExpressionList leaf) {
    this.descriptor = new TripletOrExpressionListDescriptor(leaf);
  }

  public TripletOrExpressionListNode (Expression exp) {
    NodeChoice choic = new NodeChoice (exp,1);

    TripletOrExpression toe = new TripletOrExpression(choic);
    NodeListOptional listOptional = new NodeListOptional();
    this.descriptor = new TripletOrExpressionListDescriptor (
		new TripletOrExpressionList(toe, listOptional) );
  }

  public TripletOrExpressionListNode (AbstractExpression exp) {
    // This is a stupid code;
    // Ought to be like ;
    // Expression e = exp.expression;
    //
    // NodeChoice choic = new NodeChoice (e,1);

    Expression empty = new Expression(null, null);
    ExpressionManager.register(empty, exp);

    NodeChoice choic = new NodeChoice (empty,1);

    TripletOrExpression toe = new TripletOrExpression(choic);
    NodeListOptional listOptional = new NodeListOptional();
    // leaf = new TripletOrExpressionList(toe, listOptional);
	this.descriptor = new TripletOrExpressionListDescriptor (
		new TripletOrExpressionList(toe, listOptional) );
  }

  /* public TripletOrExpressionListNode (AbstractPrimaryExpression exp) {
    PrimaryExpression emptyPrimary = new PrimaryExpression(null, null);
    PrimaryExpressionManager.register(emptyPrimary, exp);

    AbstractExpression aexp = new PrimaryExpressionNode(emptyPrimary);

    Expression empty = new Expression(null, null); 
    ExpressionManager.register(empty, aexp); 
  
    NodeChoice choic = new NodeChoice (empty,1); 

    TripletOrExpression toe = new TripletOrExpression(choic); 
    NodeListOptional listOptional = new NodeListOptional(); 
    // leaf = new TripletOrExpressionList(toe, listOptional); 
	this.descriptor = new TripletOrExpressionListDescriptor (
		new TripletOrExpressionList(toe, listOptional) );
  } */

  public void accept(AbstractExpressionVisitor v) {
    v.visit(this);
  }
}
