/*
 * File         : ClassReflectorDescriptor.java
 * Author       : Guansong Zhang, Han-Ku Lee
 * Created      : Tue May 19 13:07:52 1998
 * Revision     : $Revision: 1.16 $
 * Updated      : $Date: 1999/12/01 19:06:51 $
 */

package hpjava.compiler.reflection;

import java.util.*;
import java.lang.reflect.*;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class ClassReflectorDescriptor {
  //protected String signature;
  public String signature;

  protected boolean isBinded = false;
  protected ClassReflector reflector = null;
  
  public String signature() {
    return signature;
  }
  
  public boolean isArray() {
    if (this instanceof ArrayReflectorDescriptor) 
      return true;
    return false;
  }

  public boolean isDistArray() {
    if (this instanceof ArrayReflectorDescriptor) {
      if ( ((ArrayReflectorDescriptor)this).isDistArray() )
        return true;
    }    

    return false;
  }

  public ClassReflectorDescriptor getComponentType() {
    if (this.isArray())
      return ((ArrayReflectorDescriptor)this).getComponentType();

    return null;

  }

  public boolean isPrimitive() {
    if (this instanceof PrimitiveTypeDescriptor) 
      return true;

    return false;
  }

  public boolean isBinded() {
    return isBinded;
  }

  public void binding() {
    if (!isArray()) {

    }
    else {



    }
  }

  public ClassReflector getReflector() {
    if (this.reflector != null)
      return this.reflector;
    else if (isArray())
      throw new Error("This is an array descritpor.");
    else
      throw new Error("This descritpor is not binded yet.");
  }

  public String toString() {
    return signature;
  }

  public String getName() {
    // a temp one.

    if(this.isDistArray()){
      if(signature.startsWith("L") && signature.endsWith(";"))
        return signature.substring(1,signature.length()-1);
      else
        return signature;
    }
    else if(this.isPrimitive()){
      return signature;
    }
    else if (this.isArray()) {
      return signature;
    }
    else {
      throw new Error("not finishted");
    }
  }

}

