/*
 * File         : ConstructorReflector.java
 * Author       : Guansong Zhang
 * Created      : Fri May 22 16:19:27 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/07/22 20:34:52 $
 */


package hpjava.compiler.reflection;

import java.io.*;
import java.lang.reflect.*;

abstract public class ConstructorReflector implements MemberReflector {

  public abstract ClassReflector getDeclaringClass();

  public abstract ModifierReflector getModifier();

  public abstract String getName();

  public void show(String space, PrintStream out) {
    out.println(space+"CONSTRUCTOR:");

    out.println(space+"  NAME:\t"+ getName());    

    ModifierReflector mr=getModifier();
    if(mr!=null)
      mr.show(space+"  ", out);
    
  }

}
