/*
 * File         : FieldReflector.java
 * Author       : Guansong Zhang
 * Created      : Mon May 18 17:20:06 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/07/23 21:56:39 $
 */

package hpjava.compiler.reflection;

import java.io.*;
import java.lang.reflect.*;

abstract public class FieldReflector implements MemberReflector {

  //public int DECLARED;
  
  //public int PUBLIC;
  
  abstract public ClassReflector getDeclaringClass();

  abstract public String getName();  

  abstract public String getTypeName();

  abstract public ModifierReflector getModifier(); 

  public void show(String space, PrintStream out) {
    out.println(space+"FIELD:");

    out.println(space+"  NAME:\t"+ getName());    

    out.println(space+"  TYPE:\t"+getTypeName());

    ModifierReflector mr=getModifier();
    if(mr!=null)
      mr.show(space+"  ", out);

  }

}
