/*
 * File         : FieldReflectorByteCode.java
 * Author       : Guansong Zhang
 * Created      : Fri May 22 11:23:47 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/10/07 22:56:14 $
 */

package hpjava.compiler.reflection;

import java.lang.reflect.*;

public class FieldReflectorByteCode extends FieldReflector {

  protected Field field;

  public FieldReflectorByteCode (Field field) {
    this.field=field;
  }

  public ClassReflector getDeclaringClass() {
    return (new ClassReflectorByByteCode(this.field.getDeclaringClass()));
  }  

  public String getName() {
    return (this.field.getName());
  }

  public String getTypeName() {
    return (this.field.getType().getName());
  }  

  public ModifierReflector getModifier() {
    return (new ModifierReflector(this.field.getModifiers()));
  }

}
