/*
 * File         : LocalNameKey.java
 * Author       : Guansong Zhang
 * Created      : Thu May 14 12:03:02 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1999/03/16 20:27:38 $
 */

package hpjava.compiler.reflection;

import java.io.*;
import java.util.*;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;

public class LocalNameKey {

  private String name;
  private ScopeDescriptor scope;

  public LocalNameKey ( String name, ScopeDescriptor scope) {
    this.name=name;
    this.scope=scope;    
  }

  public LocalNameKey (NodeToken n) {
    this.name = n.tokenImage;
    this.scope = ScopeManager.scopeOf(n);
  }

  public boolean equals(Object another) {
    LocalNameKey key = (LocalNameKey) another;
    if ( (name.equals(key.name)) && (scope.equals(key.scope)) )
      return true;
    else
      return false;  
  }

  public int hashCode() {
    return name.hashCode();
  }

  public String toString() {
    return (name+"."+scope.toString());  
  }
}
