/*
 * File         : LocalVariableDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Thu May 14 12:03:02 1998
 * Revision     : $Revision: 1.6 $
 * Updated      : $Date: 1999/03/16 20:27:39 $
 */

package hpjava.compiler.reflection;

import java.io.*;
import java.util.*;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;

public class LocalVariableDescriptor {
  private String name;  
  private ClassReflectorDescriptor crd;
  
  private boolean isFinal, isParameter;

  public LocalVariableDescriptor (String name, 
                                  ClassReflectorDescriptor crd, 
                                  boolean isFinal, 
                                  boolean isParameter) {
    this.name=name;

    this.crd=crd;

    this.isFinal = isFinal;
    this.isParameter = isParameter;
        
  }

  public LocalVariableDescriptor (String name, 
                                  ClassReflectorDescriptor crd) {
    this(name, crd, false, false);
  }

  public String name() {
    return name;
  }
  
  public ClassReflectorDescriptor classReflectorDescriptor() {
    return crd;
  }
  
  public String typeSignature() {
    return crd.signature;
  }
  
  public boolean isFinal() {
    return isFinal;
  }
  
  public boolean isParameter () {
    return isParameter;
  }

  public String toString() {
    return crd.signature;
  
  }

}
