/*
 * File         : MethodReflector.java
 * Author       : Guansong Zhang
 * Created      : Fri May 22 12:09:42 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1999/09/03 20:06:34 $
 * Reviser      : Han-Ku Lee
 */

package hpjava.compiler.reflection;

import java.io.*;
import java.lang.reflect.*;

abstract public class MethodReflector implements MemberReflector {

  //public int DECLARED;
  
  //public int PUBLIC;
  
  public abstract ClassReflector getDeclaringClass();

  public abstract ModifierReflector getModifier();

  public abstract String getName();

  public abstract ClassReflector[] getParameterTypes();

  public abstract String getReturnTypeName();

  //public abstract String [] getExceptionTypeNames();

  public void show(String space, PrintStream out) {
    out.println(space+"METHOD:");

    out.println(space+"  NAME:\t"+ getName());    

    out.println(space+"  RETURNTYPE:\t"+getReturnTypeName());
    
    ModifierReflector mr=getModifier();
    if(mr!=null)
      mr.show(space+"  ", out);

  }

}
