/*
 * File         : MethodReflectorByteCode.java
 * Author       : Guansong Zhang
 * Created      : Fri May 22 12:09:42 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1999/09/03 20:06:35 $
 * Reviser      : Han-Ku Lee
 */

package hpjava.compiler.reflection;

import java.lang.reflect.*;

public class MethodReflectorByteCode extends MethodReflector {
  
  protected Method method;

  MethodReflectorByteCode (Method method) {
    this.method=method;
  }

  public ClassReflector getDeclaringClass() {
    return (new ClassReflectorByByteCode(this.method.getDeclaringClass()));
  }  
  
  public String getName() {
    return (this.method.getName());
  }

  public ClassReflector[] getParameterTypes(){
    Class[] cls = this.method.getParameterTypes();
    ClassReflector[] parametertypes = null;

    for(int i=0; i<cls.length; i++){
      try{
        parametertypes[i] = ClassReflector.forName(cls[i].getName());
      }
      catch(ClassNotFoundException cnf){
        System.out.println("ClassNotFoundException occurred ...");
      }  
    }

    return parametertypes;
  }

  public String getReturnTypeName() {
    return method.getReturnType().getName();
  }

  public ModifierReflector getModifier() {
    return (new ModifierReflector(this.method.getModifiers()));
  }

}
