/*
 * File         : NameSpaceDescriptor.java
 * Author       : Han-Ku Lee, Guansong Zhang
 * Created      : Thu May 14 12:03:02 1998
 * Revision     : $Revision: 1.6 $
 * Updated      : $Date: 1999/12/01 19:06:57 $
 *
 * Revisor      : Han-Ku Lee
 * Revised Date : Wed March 17, 1999
 */

package hpjava.compiler.reflection;

import java.io.*;
import java.util.*;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class NameSpaceDescriptor implements Cloneable {
  public StringBuffer pnameBuffer = new StringBuffer();
  public Vector inames = new Vector();
  public String cname = new String();
  
  NameSpaceDescriptor() {
    PackageNameCatcher pfinder = new PackageNameCatcher(this.pnameBuffer);
    ImportNamesCatcher ifinder = new ImportNamesCatcher(this.inames);
  } 

  NameSpaceDescriptor(Node root) {
    PackageNameCatcher pfinder = new PackageNameCatcher(this.pnameBuffer);
    root.accept(pfinder);
    ImportNamesCatcher ifinder = new ImportNamesCatcher(this.inames);
    root.accept(ifinder);
  } 

  public String toString() {
    return "<"+pnameBuffer+"> " + inames + " " + "[" + cname + "]";
  }
  
  public String pname() {
    return pnameBuffer.toString();    
  }
  
  public Vector inames() {
    return inames;  
  }

  public String cname() {
    return cname;  
  }

  public Object clone() {
    try{
       NameSpaceDescriptor theClone = (NameSpaceDescriptor)super.clone();
       theClone.pnameBuffer = (StringBuffer)this.pnameBuffer;      
       theClone.inames = (Vector)this.inames.clone();
//       theClone.cname = (String)this.cname.clone();

      return (Object)theClone;      
    }
    catch(CloneNotSupportedException e){
      return null;
    }
  }

}
