/*
 * File         : NameSpaceManager.java
 * Author       : Han-Ku Lee
 * Created      : Tue March 9, 1999
 * 
 * Updated      : Wed March 17, 1999
 */

package hpjava.compiler.reflection;

import java.io.*;
import java.util.*;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class NameSpaceManager {

  public static Hashtable rootSpaceTable  = new Hashtable();

  public NameSpaceManager(Node root){
    NameSpaceFinder finder = new NameSpaceFinder(rootSpaceTable, root);
    root.accept(finder);
//    System.out.println("Total number of identifier: " + rootSpaceTable.size());

//    Enumeration k = rootSpaceTable.keys(); 
//    for(Enumeration e = rootSpaceTable.elements(); e.hasMoreElements();){
//      System.out.println(k.nextElement().toString());
//      System.out.println(e.nextElement().toString());
//      System.out.println();
//    }
  }
 
  public NameSpaceManager (Project prj) {

    Enumeration enum = prj.rootFileTable.keys();
   
    LOOP: while (enum.hasMoreElements()) {
      
      Node root = (Node) enum.nextElement();      

      NameSpaceFinder finder = new NameSpaceFinder(rootSpaceTable, root);    

      root.accept(finder);

    } 

    if (prj.isVerbose()) {
      System.err.println("Name Space: "+rootSpaceTable);  
      System.err.println();
    } 

  }

  public static NameSpaceDescriptor nameSpaceOf(Node root) {
    return (NameSpaceDescriptor)(rootSpaceTable.get(root));
  }

} 
