/*
 * File         : ScopeDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Wed Jul 29 13:49:22 1998
 * Revision     : $Revision: 1.7 $
 * Updated      : $Date: 1999/03/16 20:27:48 $
 */

package hpjava.compiler.reflection;

import java.io.*;
import java.util.*;

import hpjava.compiler.util.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class ScopeDescriptor {

  static final String treeName = "hpjava.compiler.syntaxtree.";

  private static int nextid = 0;
  private int id;
  
  private PositionDescriptor pd;
  
  private Node s;

  // used only for creating a global scope.
  
  protected ScopeDescriptor() {
    this.id = nextid;
    nextid++;
  }

  public ScopeDescriptor(Node s) {
    this.s = s;
    this.id = nextid;    
    nextid++;

    NodeToken first;

    FirstTokenFinder ftFinder = new FirstTokenFinder();

    try {
      s.accept(ftFinder);
    }  
    catch (FirstTokenEncounterException e) {
      first = e.token;
      
      pd = new PositionDescriptor(first);
    }  
     
  }

  public int id() {
    return this.id;
  }

  public Node node() {
    return s;
  }

  public String toString() {
    String suffix = s.getClass().getName().substring(treeName.length());
  
    if (s != null )
      return ("Scope<"+pd.line()+"/"+pd.column()+":"+suffix+">");
    else 
      return ("Scope<0:Global>");
  }
  
}
