package hpjava.compiler.reflection;

import java.io.*;
import java.util.*;

import hpjava.compiler.parser.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class Test {
  public static void main(String args[]) {

    HPJavaParser parser;
    if (args.length == 0) {
      System.err.println("Java Parser Version 1.1:  Reading from standard " +
                         "input . . .");
      parser = new HPJavaParser(System.in);
    } 
    else if (args.length == 1) {
      System.err.println("Java Parser Version 1.1:  Reading from file " +
                         args[0] + " . . .");
      try {
        parser = new HPJavaParser(new java.io.FileInputStream(args[0]));
      } catch (java.io.FileNotFoundException e) {
        System.err.println("Java Parser Version 1.1:  File " + args[0] +
                           " not found.");
        return;
      }
    }
    else if (args.length == 2) {
      if (args[0].equals("-t"))
//        tree = true;

      System.err.println("Java Parser Version 1.1:  Reading from file " +
                         args[1] + " . . .");
      try {
        parser = new HPJavaParser(new java.io.FileInputStream(args[1]));
      } catch (java.io.FileNotFoundException e) {
        System.err.println("Java Parser Version 1.1:  File " + args[1] +
                           " not found.");
        return;
      }
    }
    else {
      System.err.println("Java Parser Version 1.1:  Usage is one of:");
      System.err.println("         java HPJavaParser < inputfile");
      System.err.println("OR");
      System.err.println("         java HPJavaParser inputfile");
      return;
    }

    try {
      //
      // Here's where the AST actions and visiting take place.
      //
      Node root = parser.CompilationUnit();
      System.err.println("Java Parser Version 1.1:  Java program parsed " +
                         "successfully.");

/**** Memory tests--you can ignore this section ****
      Runtime rt = Runtime.getRuntime();
      rt.gc();
      System.out.println("Total Memory in VM: " +
                         Long.toString(rt.totalMemory()));
      System.out.println("Total Free Memory:  " +
                         Long.toString(rt.freeMemory()));
      System.in.read();
 **** Memory tests--you can ignore this section ****/

      //NameSpaceFinder nsf = new NameSpaceFinder(root);
      NameSpaceManager nsm = new NameSpaceManager(root);

      //MemberNameManager mnm = new MemberNameManager(root);

    } catch (ParseException e) {
      System.err.println(e.getMessage());
      System.err.println("Java Parser Version 1.1:  Encountered errors " +
                         "during parse.");
    }


   }
}
