/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:17 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

/**
 * Grammar production:
 * <PRE>
 * f0 -> [ "public" | "protected" | "private" ]
 * f1 -> &lt;IDENTIFIER&gt;
 * f2 -> FormalParameters()
 * f3 -> [ "throws" NameList() ]
 * f4 -> "{"
 * f5 -> [ ExplicitConstructorInvocation() ]
 * f6 -> ( BlockStatement() )*
 * f7 -> "}"
 * </PRE>
 */
public class ConstructorDeclaration extends SyntaxNode implements Node {
   private Node parent;
   public NodeOptional f0;
   public NodeToken f1;
   public FormalParameters f2;
   public NodeOptional f3;
   public NodeToken f4;
   public NodeOptional f5;
   public NodeListOptional f6;
   public NodeToken f7;

   public ConstructorDeclaration(NodeOptional n0, NodeToken n1, FormalParameters n2, NodeOptional n3, NodeToken n4, NodeOptional n5, NodeListOptional n6, NodeToken n7) {
      f0 = n0;
      if (f0!=null) f0.setParent(this);
      f1 = n1;
      if (f1!=null) f1.setParent(this);
      f2 = n2;
      if (f2!=null) f2.setParent(this);
      f3 = n3;
      if (f3!=null) f3.setParent(this);
      f4 = n4;
      if (f4!=null) f4.setParent(this);
      f5 = n5;
      if (f5!=null) f5.setParent(this);
      f6 = n6;
      if (f6!=null) f6.setParent(this);
      f7 = n7;
      if (f7!=null) f7.setParent(this);
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() {
      if (parent == null) throw new Error("Parent not set.");
      return parent;
   }
   public void setChildAt(Node n, int i) {
      if (i == 0)
         f0 = (NodeOptional) n;
      else if (i == 1)
         f1 = (NodeToken) n;
      else if (i == 2)
         f2 = (FormalParameters) n;
      else if (i == 3)
         f3 = (NodeOptional) n;
      else if (i == 4)
         f4 = (NodeToken) n;
      else if (i == 5)
         f5 = (NodeOptional) n;
      else if (i == 6)
         f6 = (NodeListOptional) n;
      else if (i == 7)
         f7 = (NodeToken) n;
      else
         throw new Error("Invalid index.");

      if (n != null) n.setParent(this);
   }

   public java.util.Vector getChildren() {
      java.util.Vector vector = new java.util.Vector(8);
      vector.addElement(f0);
      vector.addElement(f1);
      vector.addElement(f2);
      vector.addElement(f3);
      vector.addElement(f4);
      vector.addElement(f5);
      vector.addElement(f6);
      vector.addElement(f7);
      return vector;
   }
}

