/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:20 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

/**
 * Grammar production:
 * <PRE>
 * f0 -> "do"
 * f1 -> Statement()
 * f2 -> "while"
 * f3 -> "("
 * f4 -> Expression()
 * f5 -> ")"
 * f6 -> ";"
 * </PRE>
 */
public class DoStatement extends SyntaxNode implements Node {
   private Node parent;
   public NodeToken f0;
   public Statement f1;
   public NodeToken f2;
   public NodeToken f3;
   public Expression f4;
   public NodeToken f5;
   public NodeToken f6;

   public DoStatement(NodeToken n0, Statement n1, NodeToken n2, NodeToken n3, Expression n4, NodeToken n5, NodeToken n6) {
      f0 = n0;
      if (f0!=null) f0.setParent(this);
      f1 = n1;
      if (f1!=null) f1.setParent(this);
      f2 = n2;
      if (f2!=null) f2.setParent(this);
      f3 = n3;
      if (f3!=null) f3.setParent(this);
      f4 = n4;
      if (f4!=null) f4.setParent(this);
      f5 = n5;
      if (f5!=null) f5.setParent(this);
      f6 = n6;
      if (f6!=null) f6.setParent(this);
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() {
      if (parent == null) throw new Error("Parent not set.");
      return parent;
   }
   public void setChildAt(Node n, int i) {
      if (i == 0)
         f0 = (NodeToken) n;
      else if (i == 1)
         f1 = (Statement) n;
      else if (i == 2)
         f2 = (NodeToken) n;
      else if (i == 3)
         f3 = (NodeToken) n;
      else if (i == 4)
         f4 = (Expression) n;
      else if (i == 5)
         f5 = (NodeToken) n;
      else if (i == 6)
         f6 = (NodeToken) n;
      else
         throw new Error("Invalid index.");

      if (n != null) n.setParent(this);
   }

   public java.util.Vector getChildren() {
      java.util.Vector vector = new java.util.Vector(7);
      vector.addElement(f0);
      vector.addElement(f1);
      vector.addElement(f2);
      vector.addElement(f3);
      vector.addElement(f4);
      vector.addElement(f5);
      vector.addElement(f6);
      return vector;
   }
}

