/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:24 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

/**
 * Grammar production:
 * <PRE>
 * f0 -> "for"
 * f1 -> "("
 * f2 -> [ ForInit() ]
 * f3 -> ";"
 * f4 -> [ Expression() ]
 * f5 -> ";"
 * f6 -> [ ForUpdate() ]
 * f7 -> ")"
 * f8 -> Statement()
 * </PRE>
 */
public class ForStatement extends SyntaxNode implements Node {
   private Node parent;
   public NodeToken f0;
   public NodeToken f1;
   public NodeOptional f2;
   public NodeToken f3;
   public NodeOptional f4;
   public NodeToken f5;
   public NodeOptional f6;
   public NodeToken f7;
   public Statement f8;

   public ForStatement(NodeToken n0, NodeToken n1, NodeOptional n2, NodeToken n3, NodeOptional n4, NodeToken n5, NodeOptional n6, NodeToken n7, Statement n8) {
      f0 = n0;
      if (f0!=null) f0.setParent(this);
      f1 = n1;
      if (f1!=null) f1.setParent(this);
      f2 = n2;
      if (f2!=null) f2.setParent(this);
      f3 = n3;
      if (f3!=null) f3.setParent(this);
      f4 = n4;
      if (f4!=null) f4.setParent(this);
      f5 = n5;
      if (f5!=null) f5.setParent(this);
      f6 = n6;
      if (f6!=null) f6.setParent(this);
      f7 = n7;
      if (f7!=null) f7.setParent(this);
      f8 = n8;
      if (f8!=null) f8.setParent(this);
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() {
      if (parent == null) throw new Error("Parent not set.");
      return parent;
   }
   public void setChildAt(Node n, int i) {
      if (i == 0)
         f0 = (NodeToken) n;
      else if (i == 1)
         f1 = (NodeToken) n;
      else if (i == 2)
         f2 = (NodeOptional) n;
      else if (i == 3)
         f3 = (NodeToken) n;
      else if (i == 4)
         f4 = (NodeOptional) n;
      else if (i == 5)
         f5 = (NodeToken) n;
      else if (i == 6)
         f6 = (NodeOptional) n;
      else if (i == 7)
         f7 = (NodeToken) n;
      else if (i == 8)
         f8 = (Statement) n;
      else
         throw new Error("Invalid index.");

      if (n != null) n.setParent(this);
   }

   public java.util.Vector getChildren() {
      java.util.Vector vector = new java.util.Vector(9);
      vector.addElement(f0);
      vector.addElement(f1);
      vector.addElement(f2);
      vector.addElement(f3);
      vector.addElement(f4);
      vector.addElement(f5);
      vector.addElement(f6);
      vector.addElement(f7);
      vector.addElement(f8);
      return vector;
   }
}

