/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:39 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

/**
 * Grammar production:
 * <PRE>
 * f0 -> NamedLocation()
 * f1 -> ( "," NamedLocation() )*
 * </PRE>
 */
public class NamedLocationList extends SyntaxNode implements Node {
   private Node parent;
   public NamedLocation f0;
   public NodeListOptional f1;

   public NamedLocationList(NamedLocation n0, NodeListOptional n1) {
      f0 = n0;
      if (f0!=null) f0.setParent(this);
      f1 = n1;
      if (f1!=null) f1.setParent(this);
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() {
      if (parent == null) throw new Error("Parent not set.");
      return parent;
   }
   public void setChildAt(Node n, int i) {
      if (i == 0)
         f0 = (NamedLocation) n;
      else if (i == 1)
         f1 = (NodeListOptional) n;
      else
         throw new Error("Invalid index.");

      if (n != null) n.setParent(this);
   }

   public java.util.Vector getChildren() {
      java.util.Vector vector = new java.util.Vector(2);
      vector.addElement(f0);
      vector.addElement(f1);
      return vector;
   }
}

