/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:41 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

import java.util.*;

/**
 * Represents a grammar choice, e.g. ( A | B )
 */
public class NodeChoice extends SyntaxNode implements Node {
   public NodeChoice(Node node) {
      this(node, -1);
   }

   public NodeChoice(Node node, int whichChoice) {
      choice = node;
      if (choice != null) choice.setParent(this);
      which = whichChoice;
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      choice.accept(v);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() { 
      if (parent == null) throw new Error("Parent not set.");
      return parent; 
   }

   public void setChildAt(Node n, int i) { 
      if (i != 0) throw new Error("Invalid Index."); 
      choice = n ; 
      if (n != null) n.setParent(this); 
   }
   public Vector getChildren() { 
      Vector vector = new Vector(1); 
      vector.addElement(choice); 
      return vector; 
   }

   private Node parent;
   public Node choice;
   public int which;
}

