/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:42 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

import java.util.*;

/**
 * Represents a grammar list, e.g. ( A )+
 */
public class NodeList extends SyntaxNode implements NodeListInterface {
   public NodeList() {
      nodes = new Vector();
   }

   public NodeList(Node firstNode) {
      nodes = new Vector();
      addNode(firstNode);
   }

   public void addNode(Node n) {
      nodes.addElement(n);
      if (n != null) 
         n.setParent(this);
      else 
         throw new Error("Node is null."); 
   }

   public Enumeration elements() { return nodes.elements(); }
   public Node elementAt(int i)  { return (Node)nodes.elementAt(i); }
   public int size()             { return nodes.size(); }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() { 
      if (parent == null) throw new Error("Parent not set.");
      return parent; 
   }

   public void setChildAt(Node n, int i) { 
      nodes.setElementAt(n,i); 
      if (n != null) n.setParent(this); 
   }
   public Vector getChildren() { 
      return nodes; 
   }

   private Node parent;
   public Vector nodes;
}

