/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.3 $ 
 * Updated      : $Date: 1999/10/31 18:22:15 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

import java.util.*;

/**
 * Represents an optional grammar list, e.g. ( A )*
 */
public class NodeListOptional extends SyntaxNode implements NodeListInterface {
   public NodeListOptional() {
      nodes = new Vector();
   }

   public NodeListOptional(Node firstNode) {
      nodes = new Vector();
      addNode(firstNode);
   }

   // add Node is to add node to the end of the list
   public void addNode(Node n) {
      nodes.addElement(n);
      if (n != null) 
         n.setParent(this);
      else 
         throw new Error("Node is null."); 
   }

   // insertNode is to add node to the beginning of the list
   public void insertNode(Node n) {
      nodes.insertElementAt( n,0 );
      if (n != null) 
         n.setParent(this);
      else 
         throw new Error("Node is null."); 
   }

   public Enumeration elements() { return nodes.elements(); }
   public Node elementAt(int i)  { return (Node)nodes.elementAt(i); }
   public int size()             { return nodes.size(); }
   public boolean present()      { return nodes.size() != 0; }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() { 
      if (parent == null) throw new Error("Parent not set.");
      return parent; 
   }

   public void setChildAt(Node n, int i) { 
      nodes.setElementAt(n, i); 
      if (n != null) n.setParent(this); 
   }
   public Vector getChildren() { 
      return nodes; 
   }

   private Node parent;
   public Vector nodes;
}

