/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:44 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

import java.util.*;

/**
 * Represents an grammar optional node, e.g. ( A )? or [ A ]
 */
public class NodeOptional extends SyntaxNode implements Node {
   public NodeOptional() {
      node = null;
   }

   public NodeOptional(Node n) {
      addNode(n);
   }

   public void addNode(Node n)  {
      if ( node != null)                // Oh oh!
         throw new Error("Attempt to set optional node twice");

      node = n;
      if (n != null) 
         n.setParent(this);
      else 
         throw new Error("Node is null."); 
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }
   public boolean present()   { return node != null; }

   public void setParent(Node n) { parent = n; }
   public Node getParent() { 
      if (parent == null) throw new Error("Parent not set.");
      return parent; 
   }

   public void setChildAt(Node n, int i) { 
      if (i != 0) throw new Error("Invalid Index."); 
      node = n ; 
      if (n != null) n.setParent(this); 
   }
   public Vector getChildren() { 
      Vector vector = new Vector(1); 
      if (node != null) { 
         vector.addElement(node); 
         return vector; 
      } 
      else 
         throw new Error("Empty NodeOptional."); 
   }

   private Node parent;
   public Node node;
}

