/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:36:54 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

/**
 * Grammar production:
 * <PRE>
 * f0 -> "return"
 * f1 -> [ Expression() ]
 * f2 -> ";"
 * </PRE>
 */
public class ReturnStatement extends SyntaxNode implements Node {
   private Node parent;
   public NodeToken f0;
   public NodeOptional f1;
   public NodeToken f2;

   public ReturnStatement(NodeToken n0, NodeOptional n1, NodeToken n2) {
      f0 = n0;
      if (f0!=null) f0.setParent(this);
      f1 = n1;
      if (f1!=null) f1.setParent(this);
      f2 = n2;
      if (f2!=null) f2.setParent(this);
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() {
      if (parent == null) throw new Error("Parent not set.");
      return parent;
   }
   public void setChildAt(Node n, int i) {
      if (i == 0)
         f0 = (NodeToken) n;
      else if (i == 1)
         f1 = (NodeOptional) n;
      else if (i == 2)
         f2 = (NodeToken) n;
      else
         throw new Error("Invalid index.");

      if (n != null) n.setParent(this);
   }

   public java.util.Vector getChildren() {
      java.util.Vector vector = new java.util.Vector(3);
      vector.addElement(f0);
      vector.addElement(f1);
      vector.addElement(f2);
      return vector;
   }
}

