/** 
 * Author       : Guansong Zhang 
 * Revision     : $Revision: 1.2 $ 
 * Updated      : $Date: 1999/03/17 16:37:01 $ 
 * Node         : Generated from JTB 1.1.1 modified by author. 
 * Copyright    : All rights reserved 
 */

package hpjava.compiler.syntaxtree;

/**
 * Grammar production:
 * <PRE>
 * f0 -> "try"
 * f1 -> Block()
 * f2 -> ( "catch" "(" FormalParameter() ")" Block() )*
 * f3 -> [ "finally" Block() ]
 * </PRE>
 */
public class TryStatement extends SyntaxNode implements Node {
   private Node parent;
   public NodeToken f0;
   public Block f1;
   public NodeListOptional f2;
   public NodeOptional f3;

   public TryStatement(NodeToken n0, Block n1, NodeListOptional n2, NodeOptional n3) {
      f0 = n0;
      if (f0!=null) f0.setParent(this);
      f1 = n1;
      if (f1!=null) f1.setParent(this);
      f2 = n2;
      if (f2!=null) f2.setParent(this);
      f3 = n3;
      if (f3!=null) f3.setParent(this);
   }

   public void accept(hpjava.compiler.visitor.Visitor v) {
      v.visit(this);
   }

   public void setParent(Node n) { parent = n; }
   public Node getParent() {
      if (parent == null) throw new Error("Parent not set.");
      return parent;
   }
   public void setChildAt(Node n, int i) {
      if (i == 0)
         f0 = (NodeToken) n;
      else if (i == 1)
         f1 = (Block) n;
      else if (i == 2)
         f2 = (NodeListOptional) n;
      else if (i == 3)
         f3 = (NodeOptional) n;
      else
         throw new Error("Invalid index.");

      if (n != null) n.setParent(this);
   }

   public java.util.Vector getChildren() {
      java.util.Vector vector = new java.util.Vector(4);
      vector.addElement(f0);
      vector.addElement(f1);
      vector.addElement(f2);
      vector.addElement(f3);
      return vector;
   }
}

