/*
 * File         : Mixer.java
 * Author       : Guansong Zhang
 * Created      : Tue Oct 27 11:53:19 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1999/11/11 01:17:09 $
 */

/* Public interface of Class Mixer:
 *
 * static public NodeToken group();
 * static public NodeToken index(NodeToken id);
 * static public NodeToken range(NodeToken id);
 * static public NodeToken location(NodeToken id);
 *
 * Generally, input of these methods are NodeTokens,
 * and these methods generate a new nodetoken output with different
 * string as the tokenImage.
 *
 * Say, input is a location variable "a", output is "a_loc_hpj" 
 *
 */

package hpjava.compiler.translator;

import hpjava.compiler.syntaxtree.*;

public class Mixer {
  static public final String suffix = "_hpj";

  static public NodeToken env() {
    StringBuffer buffer = new StringBuffer();
    buffer.append("spmd");
    buffer.append(suffix);
    return new NodeToken(buffer.toString());
  }

  //static public NodeToken group() {
  static public NodeToken group(NodeToken id) {
    StringBuffer buffer = new StringBuffer(id.tokenImage);
    //buffer.append("grp");
    buffer.append("_grp");
    buffer.append(suffix);
    return new NodeToken(buffer.toString());
  }

  static public NodeToken index(NodeToken id) {
    StringBuffer buffer = new StringBuffer(id.tokenImage);
    buffer.append("_idx");
    buffer.append(suffix);
    return new NodeToken(buffer.toString());
  }

  static public NodeToken range(NodeToken id) {
    StringBuffer buffer = new StringBuffer(id.tokenImage);
    buffer.append("_rng");
    buffer.append(suffix);
    return new NodeToken(buffer.toString());
  }

  // This method is added by Qiang Zheng to generate
  // location variables
  static public NodeToken location(NodeToken id) {
    StringBuffer buffer = new StringBuffer(id.tokenImage);
    buffer.append("_loc");
    buffer.append(suffix);
    return new NodeToken(buffer.toString());
  }
}
