package hpjava.compiler.unparser;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;
import hpjava.compiler.parser.*;
import hpjava.compiler.abstractexp.*;

import java.util.*;
import java.io.*;

public class IPrettyPrinter extends PrettyPrinter {
//   protected PrintWriter out;
//   protected Space spc; 

   public IPrettyPrinter()  { 
    super(); 

    // discard the one created by its super class;
    this.spc = new Space(3);
   }
   
   public IPrettyPrinter(Writer o)   { 
    super(o); 

    // discard the one created by its super class;
    this.spc = new Space(3);
   }
   
   public IPrettyPrinter(OutputStream o)  {
    super(o); 

    // discard the one created by its super class;
    this.spc = new Space(3);
   }

  public IPrettyPrinter(AbstractExpressionPrettyPrinter apepp) { 
    super(apepp.out);
    
    this.spc = apepp.spc;
  }

  public void flushWriter()     { out.flush(); }

  // Write your own code from here

   //
   // f0 -> PrimaryExpression()
   // f1 -> ( "/" PrimaryExpression() )*
   //
  public void visit(GroupExpression n) {
    flushWriter();
    AbstractExpressionPrettyPrinter aepp = 
      new AbstractExpressionPrettyPrinter(this);
    
    AbstractExpression aeNode = ExpressionManager.lookup(n);
    aeNode.accept(aepp);
  }


   //
   // f0 -> PreIncrementExpression()
   //       | PreDecrementExpression()
   //       | PrimaryExpression() [ "++" | "--" | AssignmentOperator() Expression() ]
   //
  public void visit(StatementExpression n) {
    flushWriter();
    AbstractExpressionPrettyPrinter aepp = 
      new AbstractExpressionPrettyPrinter(this);
    
    AbstractExpression aeNode = ExpressionManager.lookup(n);
    aeNode.accept(aepp);
  }

   //
   // f0 -> ConditionalExpression()
   // f1 -> [ AssignmentOperator() Expression() ]
   //
  public void visit(Expression n) {
    flushWriter();
    AbstractExpressionPrettyPrinter aepp = 
      new AbstractExpressionPrettyPrinter(this);
    
    AbstractExpression aeNode = ExpressionManager.lookup(n);
    aeNode.accept(aepp);
  }


  /*
   //
   // f0 -> PrimaryPrefix()
   // f1 -> ( PrimarySuffix() )*
   //

  public void visit(PrimaryExpression n) {
    flushWriter();
    AbstractPrimaryExpression node = PrimaryExpressionManager.lookup(n);

    flushWriter();
    node.accept (new AbstractPrimaryExpressionPrettyPrinter(this));
  }
  */
  

}
