/*
 * File         : IUnparsePrinter.java
 * Author       : Han-Ku Lee
 * Created      : Thu Oct  8 16:10:59 1998
 * Revision     : $Revision: 1.10 $
 * Updated      : $Date: 1999/06/08 19:37:56 $
 */

package hpjava.compiler.unparser;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

//import hpjava.compiler.parser.*;
import hpjava.compiler.abstractexp.*;

import java.util.*;
import java.io.*;


public class IUnparsePrinter extends UnparsePrinter {
  
  public IUnparsePrinter() { 
    // super();
  }

  public IUnparsePrinter(Writer o) { 
    super(o);
  }

  public IUnparsePrinter(OutputStream o)  { 
    super(o); 
  }

  public IUnparsePrinter(AbstractExpressionUnparsePrinter aeup) { 
    super(aeup.out);
    
    this.previous = aeup.previous;
    
    // discard the one created by its super class;
    this.posCounter = aeup.posCounter;
  }

  /*
  public IUnparsePrinter(AbstractPrimaryExpressionUnparsePrinter apeup) { 
    super(apeup.out);
    
    this.previous = apeup.previous;
    
    // discard the one created by its super class;
    this.posCounter = apeup.posCounter;
  }
  */

   //
   // f0 -> PrimaryExpression()
   // f1 -> ( "/" PrimaryExpression() )*
   //
  public void visit(GroupExpression n) {
    flushWriter();
    AbstractExpressionUnparsePrinter aeup = 
      new AbstractExpressionUnparsePrinter(this);
    
    AbstractExpression aeNode = ExpressionManager.lookup(n);
    aeNode.accept(aeup);
  }


   //
   // f0 -> PreIncrementExpression()
   //       | PreDecrementExpression()
   //       | PrimaryExpression() [ "++" | "--" | AssignmentOperator() Expression() ]
   //
  public void visit(StatementExpression n) {
    flushWriter();
    AbstractExpressionUnparsePrinter aeup = 
      new AbstractExpressionUnparsePrinter(this);
    
    AbstractExpression aeNode = ExpressionManager.lookup(n);
    aeNode.accept(aeup);
  }

   //
   // f0 -> ConditionalExpression()
   // f1 -> [ AssignmentOperator() Expression() ]
   //
  public void visit(Expression n) {
    flushWriter();
    AbstractExpressionUnparsePrinter aeup = 
      new AbstractExpressionUnparsePrinter(this);
    
    AbstractExpression aeNode = ExpressionManager.lookup(n);
    aeNode.accept(aeup);
  }



   //
   // f0 -> PrimaryPrefix()
   // f1 -> ( PrimarySuffix() )*
   //

  public void visit(PrimaryExpression n) {
    flushWriter();
    AbstractExpressionUnparsePrinter aeup = 
      new AbstractExpressionUnparsePrinter(this);
    
    AbstractExpression aeNode = ExpressionManager.lookup(n);
    aeNode.accept(aeup);
  }
  
}
