/*
 * File         : CMDline.java
 * Author       : Guansong Zhang
 * Created      : Thu May 14 12:03:02 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/12/11 15:25:04 $
 */

package hpjava.compiler.util;
import java.util.*;

public class CMDline {
  
  // public data, too simple to use isSomthing pattern.
  // pay attention to deferent platforms' javac command.
  
  protected boolean minusg=false;
  protected boolean minusO=false;
  protected boolean debug=false;
  protected boolean depend=false;
  protected boolean nowarn=false;
  protected boolean verbose=false;
  protected String classpath=null;
  protected boolean nowrite=false;
  protected boolean deprecation=false;
  protected String dir=null;
  protected String runtimeFlag=null;
  protected Vector files = new Vector(10);
  
  protected boolean cat=false;

  public CMDline (String[] argv) 
    throws MissingFileException, 
           InvalidCMDflagException, 
           InvalidFileNameException {

    for (int i=0; i<argv.length; i++) {
      if (argv[i].startsWith("-")) {

        if (argv[i].equals("-g")) {
          minusg=true;
          continue; 
        }  

        if (argv[i].equals("-O")) {
          minusO=true;
          continue; 
        }  

        if (argv[i].equals("-debug")) {
          debug=true;
          continue;
        }

        if (argv[i].equals("-depend")) {
          depend=true;
          continue;
        }

        if (argv[i].equals("-nowarn")) {
          nowarn=true;
          continue;
        }

        if (argv[i].equals("-verbose") || argv[i].equals("-v")) {
          verbose=true;
          continue;
        }

        if (argv[i].equals("-classpath")) {
          i++;
          classpath=argv[i];
          continue;
        }

        if (argv[i].equals("-nowrite")) {
          nowrite=true;
          continue;
        }

        if (argv[i].equals("-deprecation")) {
          deprecation=true;
          continue;
        }

        if (argv[i].equals("-d")) {
          i++;
          dir=argv[i];
          continue;
        }

        if (argv[i].equals("-J")) {
          i++;
          runtimeFlag=argv[i];
          continue;
        }
        
        if (argv[i].equals("-cat") || argv[i].equals("-c")) {
          cat=true; 
          continue;
        }

        throw new InvalidCMDflagException(argv[i]);

      } else {      

        if (argv[i].endsWith(".hpj") || argv[i].endsWith(".java"))
          files.addElement(argv[i]);
        else         
          throw new InvalidFileNameException(argv[i]);        
        
      }
    }
    
    if (files.size()==0)
      throw new MissingFileException();      
              
// DEBUG
//  if (cmd.isVerbose())
//    System.err.println("Commandline: "+cmd);

  }
  

  public boolean isMinusg() {
    return minusg;
  }

  public boolean isMinusO() {
    return minusO;
  }
  
  public boolean isDebug() {
    return debug;
  }

  public boolean isDepend() {
    return depend;
  }

  public boolean isNowarn() {
    return nowarn;
  }
  
  public boolean isVerbose() {
    return verbose;
  }

  public boolean hasClasspath() {
    if (classpath == null)
      return false;
    else
      return true;
  }

  public String getClasspath() {
    return classpath;
  }

  public boolean isNowrite() {
    return nowrite;
  }

  public boolean isDeprecation() {
    return deprecation;
  }

  public boolean hasDir() {
    if (dir == null)
      return false;
    else
      return true;
  }

  public String getDir() {
    return dir;
  }

  public boolean hasRuntimeFlag() {
    if (runtimeFlag == null)
      return false;
    else
      return true;
  }

  public String getRuntimeFlag() {
    return runtimeFlag;
  }

  public Vector getFiles() {
    return files;
  }

  public boolean isCat() {
    return cat;
  }

  public String toString() {
    String cmdline=""; // not null but "" 
    
    if (minusg) 
      cmdline=cmdline+"-g ";
      
    if (minusO)
      cmdline=cmdline+"-O ";
      
    if (debug)
      cmdline=cmdline+"-debug ";
          
    if (depend)
      cmdline=cmdline+"-depend ";
      
    if (nowarn)
      cmdline=cmdline+"-nowarn ";
      
    if (classpath != null)
      cmdline=cmdline+"-classpath "+classpath+" ";
            
    if (nowrite)
      cmdline=cmdline+"-nowrite ";
      
    if (deprecation)
      cmdline=cmdline+"-deprecation ";
      
    if (dir != null )
      cmdline=cmdline+"-d "+dir+" ";
          
    if (runtimeFlag != null )
      cmdline=cmdline+"-J "+runtimeFlag+" ";
      
    Enumeration e=files.elements();
     
    while (e.hasMoreElements()) {
      cmdline=cmdline+e.nextElement().toString()+" ";      
    }   
      
    return cmdline;    

  }

}                                                                              
