/*
 * File         : CompilingError.java
 * Author       : Guansong Zhang
 * Created      : Thu May 14 12:03:02 1998
 * Revision     : $Revision: 1.6 $
 * Updated      : $Date: 1999/03/16 20:30:08 $
 */

package hpjava.compiler.util;

import hpjava.compiler.syntaxtree.*;

import hpjava.compiler.reflection.*;

public class CompilingError extends Error {
  
  static private int number=0;
  
  private String message;  
  private String  fileName ;

  private PositionDescriptor pd;
  
  public CompilingError (String m, NodeToken n) {
    //super();
      
    number++;
    message=m;

    Node root= n;
    
    while (!(root instanceof CompilationUnit)) {
      //System.out.println(root+ScopeManager.scopeOf(root).toString());
      root = ScopeManager.scopeOf(root).node();
    }

    fileName=(String)Project.rootFileTable.get(root);

    pd = new PositionDescriptor(n);

  }

  static public int number() {
    return number;
  }
  
  public String getMessage() {
    StringBuffer buffer = new StringBuffer();

    buffer.append(fileName+":");
//    buffer.append(" line: "+pos[0]+" column: "+pos[1]);

    buffer.append(pd.line()+": ");
    buffer.append(message);

    return buffer.toString();   
  }
}                                                                              
