/*
 * File         : PositionDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Thu Aug 27 17:19:30 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1999/03/16 20:30:12 $
 */

package hpjava.compiler.util;

import java.io.*;
import java.util.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

public class PositionDescriptor {
  private int [] pos = new int [4];

  public NodeToken token;

  public PositionDescriptor (NodeToken token) {
    this.token = token;

    this.token.accept(new PositionFinder(pos));
  }

  public int line() {
    return pos[0];
  }
  
  public int column() {
    return pos[1];
  }
  
  public String toString() {
    return token.tokenImage+":"+pos[0]+":"+pos[1];
  }
}


/*
 * File         : PositionFinder.java
 * Author       : Guansong Zhang
 * Created      : Thu May 14 12:03:02 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1999/03/16 20:30:12 $
 */

class PositionFinder extends DepthFirstVisitor {

  final int SIZE=4;
  
  private int[] pos;
  
  boolean debug=false;

  public PositionFinder() {
    pos= new int[SIZE];
    debug=true;
  }

  public PositionFinder(int[] pos) {
    if (pos.length >= 4)
      this.pos=pos;
    else
      throw new Error("Invalid array: "+ pos.toString());
  }

  // token;

  public void visit (NodeToken n) {
    pos[0] = n.beginLine;
    pos[1] = n.beginColumn;
    pos[2] = n.endLine;
    pos[3] = n.endColumn;
  }
 
}
