/*
 * File         : RecoveryVisitor.java
 * Author       : Guansong Zhang
 * Created      : Thu May 14 12:03:02 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1999/03/16 20:30:14 $
 */

package hpjava.compiler.util;

import java.io.*;
import java.util.*;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

abstract public class RecoveryVisitor extends DepthFirstVisitor {
  public void recoveryVisit(NodeListOptional n) {      
    if ( n.present() ) {
       for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
         try {
            ((Node)e.nextElement()).accept(this);
         }
         catch (CompilingError err) {
            System.err.println();
            System.err.println(err.getMessage());
         }
       }
    }      
  }

}
