/*
 * File         : LocalVariableDeclarationDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Tue Oct 27 11:53:19 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/06/08 14:58:45 $
 */

package hpjava.compiler.wrapper;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

import hpjava.compiler.unparser.*;

import hpjava.compiler.abstractexp.*;
import hpjava.compiler.reflection.*;

public class LocalVariableDeclarationDescriptor {
  public LocalVariableDeclaration leaf;

  public LocalVariableDeclarationDescriptor(LocalVariableDeclaration leaf) {
    this.leaf = leaf;
  }

  public LocalVariableDeclarationDescriptor(Type type, VariableDeclarator var) {
    leaf = new LocalVariableDeclaration(new NodeOptional(),
                                        type, var,
                                        new NodeListOptional());

  }

  public int numberOfVars() {
    return 1+ leaf.f3.size();
  }

  public VariableDeclarator var(int i) {
    if (i==0) {
      return (VariableDeclarator)leaf.f2;
    }
    else {
	  // Modified by Qiang Zheng
      // Original: return (VariableDeclarator) leaf.f3.elementAt(i-1);
	  // LocalVariableDeclaration.f3 is NodeListOptional
	  // leaf.f3.elementAt(i-1) is a NodeSequence: ", VariableDeclarator()"
      return (VariableDeclarator) ( (NodeSequence)leaf.f3.elementAt(i-1)).elementAt(1);
    }
  }
}
