/*
 * File         : NamedLocationListDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Wed Oct 28 10:32:58 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/10/29 21:59:03 $
 */

package hpjava.compiler.wrapper;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

import hpjava.compiler.unparser.*;

/**
 * Grammar production:
 * <PRE>
 * f0 -> NamedLocation()
 * f1 -> ( "," NamedLocation() )*
 * </PRE>
 */

public class NamedLocationListDescriptor {
  public NamedLocationList leaf;

  public NamedLocationListDescriptor (NamedLocationList leaf) {
    this.leaf = leaf;
  }

  public int numberOfLocs() {
    return 1 + leaf.f1.size();
  }

  public NamedLocation loc(int i) {
    if (i==0) {
      return leaf.f0;
    }
    else {
      return (NamedLocation) leaf.f1.elementAt(i-1);
    }
  }

  public NodeToken name(int i) {
    NamedLocation loc = loc(i);

    return loc.f0;
  }

  public PrimaryExpression base(int i) {
    NamedLocation loc = loc(i);

    return loc.f2;
  } 

  /*
  public boolean hasRangeSpecifier(int i) {
    NamedLocation loc = loc(i);

    return loc.f3.present();
  }

  public Triplet range(int i) {
    if (hasRangeSpecifier(i)) {
      NamedLocation loc = loc(i);      
      return (Triplet) loc.f3.node;
    }
    else 
      throw new Error("No range specified.");

  }
  */
  public void addLoc(NamedLocation loc) {
    if (leaf.f0 == null)
      leaf.f0=loc;
    else 
      leaf.f1.addNode(loc);
  }

}
