/*
 * File         : VariableDeclaratorDescriptor.java
 * Author       : Guansong Zhang
 * Created      : Wed Aug 12 14:23:07 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1999/03/16 20:30:21 $
 */

package hpjava.compiler.wrapper;

import hpjava.compiler.syntaxtree.*;
import hpjava.compiler.visitor.*;

import hpjava.compiler.reflection.*;

import hpjava.compiler.unparser.*;

public class VariableDeclaratorDescriptor {
  public VariableDeclarator leaf;
  
  public VariableDeclaratorDescriptor (VariableDeclarator leaf) {
    this.leaf = leaf;
  }

  public VariableDeclaratorDescriptor ( VariableDeclaratorId id ) {
    leaf = new VariableDeclarator( id, new NodeOptional());
  }

  public void setInitializer(Expression exp) {
    NodeOptional optional = this.leaf.f1;

    if (optional.present())
      throw new Error("Initializer already exist.");

    NodeSequence sequence = new NodeSequence(2);
    sequence.addNode(new NodeToken("="));
    
    VariableInitializer initializer = 
      new VariableInitializer(new NodeChoice(exp, 1));

    sequence.addNode(initializer);

    optional.addNode(sequence);
                                                           
  }

}

