package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Adlib extends InterfaceObject {

  static public native void _Initialize(String[] args);
  static public native void _Finalize();
  static public native void _InitInterFace();  
  static public native void _InitAPG(Group apg);

  static public void remap(Section dst, Section src) {

    //dst.dad.show("dst"); //debug
    //src.dad.show("src"); //debug

    Remap schedule=new Remap(dst.dad, src.dad, dst.type);
    schedule.execute(dst.reference, dst.offset, src.reference, src.offset);
  };
  
  static public void shift(Section dst, Section src, int shift, int dim, int mode) {
    Shift schedule=new Shift(dst.dad, src.dad, dst.type, shift, dim, mode);
    schedule.execute(dst.reference, dst.offset, src.reference, src.offset);
  };

  static public void copy(Section dst, Section src) {
    // This is temporaryly implemented as remap;

    Remap schedule=new Remap(dst.dad, src.dad, dst.type);
    schedule.execute(dst.reference, dst.offset, src.reference, src.offset);
  };

  static public void writeHalo(Section src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule=new WriteHalo(src.dad, src.type, wlo, whi, mode);
    schedule.execute(src.reference, src.offset);
  };

  static public void writeHalo(Section src, int[] wlo, int[] whi) {
    WriteHalo schedule=new WriteHalo(src.dad, src.type, wlo, whi);
    schedule.execute(src.reference, src.offset);
  };

  static public native void _aprintf(String control, 
				     DAD dad, int type, Object ref, int ost);

  static public void aprintf(String control, Section arg) {
    _aprintf(control, arg.dad, arg.type, arg.reference, arg.offset);
  };

  //using java buffer is different from C buffer
  //so a native method is added.

  static private native void printString(String s);

  static public void rprint(String x) {
    Procs0 root = new Procs0();
    if (root.on()) {
      printString(x+"");
    } root.no();
  }

  static public void rprintln(String x) {
    Procs0 root = new Procs0();
    if (root.on()) {
      printString(x+"\n");
    } root.no();
  }
  
//   static public void Initialize(String[] args) {
//     Spmd.Initialize(args);
//   };

//   static public void Finalize() {
//     Spmd.Finalize();
//   };
  
//   static public Group apg;
//   static public Group global;
//   static public Group root;

}
